/*************************************************************************/ /*!
@File
@Title          fp_hw_util.h
@Copyright      Copyright (c) Milandr. All Rights Reserved
@Description    generic hw utilities
@License        Dual MIT/GPLv2

The contents of this file are subject to the MIT license as set out below.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Alternatively, the contents of this file may be used under the terms of
the GNU General Public License Version 2 ("GPL") in which case the provisions
of GPL are applicable instead of those above.

If you wish to allow use of your version of this file only under the terms of
GPL, and not to allow others to use your version of this file under the terms
of the MIT license, indicate your decision by deleting the provisions above
and replace them with the notice and other provisions required by GPL as set
out in the file called "GPL-COPYING" included in this distribution. If you do
not delete the provisions above, a recipient may use your version of this file
under the terms of either the MIT license or GPL.

This License is also included in this distribution in the file called
"MIT-COPYING".

EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/ /**************************************************************************/

#ifndef _FP_HW_UTIL_H_
#define _FP_HW_UTIL_H_

#ifdef FP_PCI_BM_EN
static inline int fp_hwcsr_rw(fp_private_t *fp)
{
    return 0;
}

static inline void fp_wsp_reset(fp_private_t *fp)
{
    /* TODO: volatile unsigned int *reset_addr;
    int reset_value = 0x100; */

    /* Reset the Device and Wake it Up */
    printk ("Resetting WSP\n");

    mdelay (100);
    printk ("Coming out of Resetting WSP\n");
}

static inline void fp_emac_enable(fp_private_t *fp)
{
    UINT value = 0;
    volatile UINT *addr;

    addr  = (unsigned int *)(0x630020 + fp->pcimem_base);
    value = *addr;
    value = value | 0x80000003;
    *addr = value;
}

#if 0
static inline void fp_phy_set_mdio_as_10_mbps(struct fp_private *fp)
{
    UINT value = 0;
    volatile UINT *addr;

    /* made fp_phy0 as 1000 mbps mode */

    /* enable emac interrupts */
    addr  = (unsigned int *)(0x660028 + fp->pcimem_base);
    *addr = 0x003fffff;

    /* enable MDIO */
    addr  = (unsigned int *)(0x660000 + fp->pcimem_base);
    *addr = 0x0000001c;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660008 + fp->pcimem_base);
    value = *addr;

    /* write 0x0000 to PHY register 9   (disable 1G advertisement) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53a60000;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* write 0x0100 to PHY register 0   (set to 10mb mode) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53820100;

    mdelay(2);
    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* write 0x8100 to PHY register 0   (soft reset) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53828100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* made fp_phy1 as 1000 mbps mode */

    /* enable emac interrupts */
    addr  = (unsigned int *)(0x670028 + fp->pcimem_base);
    *addr = 0x003fffff;

    /* enable MDIO */
    addr  = (unsigned int *)(0x670000 + fp->pcimem_base);
    *addr = 0x0000001c;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670008 + fp->pcimem_base);
    value = *addr;

    /* write 0x0000 to PHY register 9   (disable 1G advertisement) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53a60000;

    mdelay(2);
    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;

    /* write 0x0100 to PHY register 0   (set to 10mb mode) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53820100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;

    /* write 0x8100 to PHY register 0   (soft reset) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53828100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;
}
#endif

static inline void fp_phy_set_mdio_as_100_mbps(fp_private_t *fp)
{
    UINT value = 0;
    volatile UINT *addr;

    /* made fp_phy0 as 100 mbps mode */

    /* enable emac interrupts */
    addr  = (unsigned int *)(0x660028 + fp->pcimem_base);
    *addr = 0x003fffff;

    /* enable MDIO */
    addr  = (unsigned int *)(0x660000 + fp->pcimem_base);
    *addr = 0x0000001c;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660008 + fp->pcimem_base);
    value = *addr;

    /* write 0x0000 to PHY register 9   (disable 1G advertisement) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53a60000;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* write 0x3100 to PHY register 0   (set to 100mb mode) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53823100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* write 0xb100 to PHY register 0   (soft reset) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x5382b100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* made fp_phy1 as 100 mbps mode */
    /* enable emac interrupts */
    addr  = (unsigned int *)(0x670028 + fp->pcimem_base);
    *addr = 0x003fffff;

    /* enable MDIO */
    addr  = (unsigned int *)(0x670000 + fp->pcimem_base);
    *addr = 0x0000001c;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670008 + fp->pcimem_base);
    value = *addr;

    /* write 0x0000 to PHY register 9   (disable 1G advertisement) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53a60000;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;

    /* write 0x3100 to PHY register 0   (set to 100mb mode) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53823100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;

    /* write 0xb100 to PHY register 0   (soft reset) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x5382b100;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;
}

static inline void fp_phy_set_mdio_as_1000_mbps(fp_private_t *fp)
{
    UINT value = 0;
    volatile UINT *addr;

    /* made fp_phy0 as 1000 mbps mode */

    /* enable emac interrupts */
    addr  = (unsigned int *)(0x660028 + fp->pcimem_base);
    *addr = 0x003fffff;

    /* enable MDIO */
    addr  = (unsigned int *)(0x660000 + fp->pcimem_base);
    *addr = 0x0000001c;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660008 + fp->pcimem_base);
    value = *addr;

    /* write 0x0000 to PHY register 9   (disable 1G advertisement) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53a60300;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* write 0x3100 to PHY register 0   (set to 100mb mode) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53821140;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* write 0xb100 to PHY register 0   (soft reset) */
    addr  = (unsigned int *)(0x660034 + fp->pcimem_base);
    *addr = 0x53829140;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x660024 + fp->pcimem_base);
    value = *addr;

    /* made fp_phy1 as 1000 mbps mode */

    /* enable emac interrupts */
    addr  = (unsigned int *)(0x670028 + fp->pcimem_base);
    *addr = 0x003fffff;

    /* enable MDIO */
    addr  = (unsigned int *)(0x670000 + fp->pcimem_base);
    *addr = 0x0000001c;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670008 + fp->pcimem_base);
    value = *addr;

    /* write 0x0000 to PHY register 9   (disable 1G advertisement) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53a60300;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;

    /* write 0x3100 to PHY register 0   (set to 100mb mode) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53821140;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;

    /* write 0xb100 to PHY register 0   (soft reset) */
    addr  = (unsigned int *)(0x670034 + fp->pcimem_base);
    *addr = 0x53829140;

    mdelay(2);

    /* read status register */
    addr  = (unsigned int *)(0x670024 + fp->pcimem_base);
    value = *addr;
}



#else
#if 0
static inline int fp_hwcsr_rw(struct fp_private *fp)
{
    volatile unsigned int *test_addr;
    unsigned int test_data1 = 0x0, test_data2 = 0;

    if(fp == NULL || fp->pcimem_base == NULL) {
        printk("Error in pci mem access\n");
        return -1;
    }

    test_addr  = (unsigned int *)(0x320004 + fp->pcimem_base);
    *test_addr = test_data1;
    test_data1 = 0x01020304;
    test_addr  = (unsigned int *)(0x800000 + fp->pcimem_base);
    *test_addr = test_data1;

    test_data2 = (unsigned int) *test_addr;
    if (test_data2 != test_data1) {
       printk ("Basic HW Rd/WR Failed : %x\n", test_data2);
       return (-ENOMEM);
    } else {
       printk ("Basic HW Rd/WR passed : %x\n", test_data2);
    }

    return 0;
}

static inline void fp_wsp_reset(struct fp_private *fp)
{
    volatile unsigned int *reset_addr;
    int reset_value = 0x100;

    /* Reset the Device and Wake it Up */
    printk ("Resetting WSP\n");
    reset_addr  = (unsigned int *)(WSP_RESET_REG + fp->pcimem_base);
    *reset_addr = reset_value;

    /* To wait for Reset to complete */
    mdelay (100);
    printk ("Coming out of Resetting WSP\n");
}

static inline void fp_emac_enable(struct fp_private *fp)
{
    volatile unsigned int *test_addr;
    unsigned int test_data1 = 0x0;

    /* Start Ethernet PHYs when we complete initialization */
    test_data1 = 0x03;
    test_addr  = (unsigned int *)(WSP_RESET_REG + fp->pcimem_base);
    *test_addr = test_data1;
}
#endif
#endif

#define ASSERT(x) \
do { \
    if (!(x)) \
    printk("%s: %d: Would have been dead here\n", __FUNCTION__, __LINE__); \
} while (0)

#endif
