/*************************************************************************/ /*!
@File
@Title          fp_bd_table.h
@Copyright      Copyright (c) Milandr. All Rights Reserved
@Description    defines for buffer descriports
@License        Dual MIT/GPLv2

The contents of this file are subject to the MIT license as set out below.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Alternatively, the contents of this file may be used under the terms of
the GNU General Public License Version 2 ("GPL") in which case the provisions
of GPL are applicable instead of those above.

If you wish to allow use of your version of this file only under the terms of
GPL, and not to allow others to use your version of this file under the terms
of the MIT license, indicate your decision by deleting the provisions above
and replace them with the notice and other provisions required by GPL as set
out in the file called "GPL-COPYING" included in this distribution. If you do
not delete the provisions above, a recipient may use your version of this file
under the terms of either the MIT license or GPL.

This License is also included in this distribution in the file called
"MIT-COPYING".

EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/ /**************************************************************************/

#ifndef _FP_BD_TABLE_H
#define _FP_BD_TABLE_H

#define BD_CTRL_BD_BUFLEN_MASK (0xffff)
#define BD_CTRL_CBD_INT_EN     (1 << 16)
#define BD_CTRL_PKT_INT_EN     (1 << 17)
#define BD_CTRL_LIFM           (1 << 18)
#define BD_CTRL_LAST_BD        (1 << 19)
#define BD_CTRL_DIR            (1 << 20)
#define BD_CTRL_PKT_XFER       (1 << 24)
#define BD_CTRL_DESC_EN        (1 << 31)
#define BD_CTRL_PARSE_DISABLE    (1 << 25)
#define BD_CTRL_BRFETCH_DISABLE  (1 << 26)
#define BD_CTRL_RTFETCH_DISABLE  (1 << 27)

struct bd {
    uint32 bd_ctrl;
    uint32 bd_status;
    uint32 bd_bufptr;
    struct bd *bd_next;
};

#endif /* _FP_BD_TABLE_H */
