/*************************************************************************/ /*!
@File
@Title          fp_ltc.h
@Copyright      Copyright (c) Milandr. All Rights Reserved
@Description    LTC related macros and functions 
@License        Dual MIT/GPLv2

The contents of this file are subject to the MIT license as set out below.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Alternatively, the contents of this file may be used under the terms of
the GNU General Public License Version 2 ("GPL") in which case the provisions
of GPL are applicable instead of those above.

If you wish to allow use of your version of this file only under the terms of
GPL, and not to allow others to use your version of this file under the terms
of the MIT license, indicate your decision by deleting the provisions above
and replace them with the notice and other provisions required by GPL as set
out in the file called "GPL-COPYING" included in this distribution. If you do
not delete the provisions above, a recipient may use your version of this file
under the terms of either the MIT license or GPL.

This License is also included in this distribution in the file called
"MIT-COPYING".

EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/ /**************************************************************************/

#ifndef  _FP_LTC_H_
#define  _FP_LTC_H_

#include <fp_macros.h>

/**********************************************************************
*                                      #defines                                               
**********************************************************************/
#define CLAMP_TIME                10 
#define LTC_ENABLE_MAGICNUM  0xdeadbeaf
#define HIF0  2
#define HIF1  3
#define LTC_DELAY                 100000
#define LTC_HIF_SECONDS           1
#define LTC_HIF_NANOSECONDS       2
#define LTC_REG_LEN		  8
#define LTC_DEV_VAL		  3            
#define LTC_CHANNEL_NUM	          4 
#define HIF0_LTC_CH0_TIME_SEC     0x00670040
#define HIF1_LTC_CH0_TIME_SEC     0x00670050
#define LTC_TSU_TIME_SEC          0x00670060
#define LTC_TSU_TIME_NSEC         0x00670064
#define LTC_HIF1_SECONDS_VAL	  0x00670024      
#define LTC_HIF1_NANOSECONDS_VAL  0x00670028      
#endif /*End of _FP_LTC_H_ */

