/*************************************************************************/ /*!
@File
@Title          hw_vlan_hash_table.h
@Copyright      Copyright (c) Milandr. All Rights Reserved
@Description    defines for vlan hash table
@License        Dual MIT/GPLv2

The contents of this file are subject to the MIT license as set out below.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Alternatively, the contents of this file may be used under the terms of
the GNU General Public License Version 2 ("GPL") in which case the provisions
of GPL are applicable instead of those above.

If you wish to allow use of your version of this file only under the terms of
GPL, and not to allow others to use your version of this file under the terms
of the MIT license, indicate your decision by deleting the provisions above
and replace them with the notice and other provisions required by GPL as set
out in the file called "GPL-COPYING" included in this distribution. If you do
not delete the provisions above, a recipient may use your version of this file
under the terms of either the MIT license or GPL.

This License is also included in this distribution in the file called
"MIT-COPYING".

EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/ /**************************************************************************/

#ifndef  _HW_VLAN_HASH_TABLE_H_
#define  _HW_VLAN_HASH_TABLE_H_

#include "fp_library.h"
#include "fp_macros.h"

#define  INDIRECT_VLAN_HASH_MAC1    0x02050404
#define  INDIRECT_VLAN_HASH_MAC2    0x02050408
#define  INDIRECT_VLAN_HASH_MAC3    0x0205040C
#define  INDIRECT_VLAN_HASH_MAC4    0x02050410
#define  INDIRECT_VLAN_HASH_MAC5    0x02050414
#define  INDIRECT_VLAN_HASH_ENTRY   0x02050418
#define  INDIRECT_VLAN_HASH_CMD     0x02050400
#define  INDIRECT_VLAN_HASH_STATUS  0x0205041C
#define  INDIRECT_VLAN_HASH_DIRECT  0x02050420

/* Vlan group table is common for all hash tables */
#define VLAN_INIT_HEAD_PTR          0x40
#define VLAN_INIT_TAIL_PTR          0x7f
#define VLAN_FREE_LIST_ENTRIES      0x40

#define  VLAN_HASH_ENTRIES          0x40
#define  VLAN_COLL_HASH_ENTRIES     0x40

int64_t wsp_vlan_entry_search(uint16_t vlanid);

int32_t wsp_vlan_entry_add(uint16_t vlanid, uint64_t action_entry);
int32_t wsp_vlan_entry_delete(uint16_t vlanid);
int32_t wsp_vlan_entry_update(uint16_t vlanid, uint64_t brentry);
void wsp_vlan_hash_table_init(void);
void wsp_read_entry_vlan_hash_table( uint32_t *entry_data, uint16_t entry_number );
uint32_t wsp_vlan_hash_table_read(uint8_t *buff);
#endif /*End of _HW_HASH_TABLE_H_*/
