
#ifndef __SFP_COPPER_SETUP_H
#define __SFP_COPPER_SETUP_H
#define SFP_MODULE_I2C_EPHY_ADDR 0x56

#define SFP_MODULE_I2C_DEV_ADDR_PARAM_POS	8
#define SFP_MODULE_I2C_DEV_ADDR_PARAM_MASK	( 0xFF << SFP_MODULE_I2C_DEV_ADDR_PARAM_POS )

#include <linux/wait.h>
#include <linux/spinlock.h>

struct sfp_copper_setup_s {	
	wait_queue_head_t sfp_copper_microtask_wait_queue;	//complete of the i2c transaction, during sfp copper configuration task is processing
	wait_queue_head_t sfp_copper_job_wait_queue;		//start sfp copper configuration task, when copper sfp connected
	spinlock_t sfp_copper_spin_lock;
	uint32_t i2c_transaction_complete;
	uint32_t has_job;
	uint32_t i2c_address;
	uint32_t return_value;
};

struct sfp_copper_thread_s {
	struct task_struct *sfp_copper_setup_thread;
};

void get_eth_phy_reg_i2c_callback( uint32_t data );
void set_eth_phy_reg_i2c_callback( uint32_t data );
uint32_t fp_sfp_copper_setup_job_start( uint32_t cmd );
void fp_sfp_copper_setup_thread_init( void );
void fp_sfp_copper_setup_thread_deinit( void );

#endif	//__SFP_COPPER_SETUP_H
