


#include <stdio.h>

//#define _USERSPACE_

#include "libcli.h"
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>


#include "fp_library.h"
#include "fp_common_msg_header.h"
#include "fp_common_ctlm.h"
#include "fp_ioctl.h"
#include <tlite_blocks_ctrl_api.h>
#include "switchApi_blocks_ctrlm.h"
#include "fpios.h"
#include "l2cli.h"
#include "fp_port.h"


extern nakCli_t nkCli;

int portlist_display_add_delete(struct cli_def *cli,  char *string, char *action)
{
    /*
	cli_print (cli, "\tEnter %s value 1 to %s port 1(EMAC1)", string, action);
	cli_print (cli,	"\tEnter %s value 2 to %s port 2(EMAC2)", string, action);
	cli_print (cli,	"\tEnter %s value 3 to %s port 3(EMAC3)", string, action);
	cli_print (cli,	"\tEnter %s value 4 to %s port 4(EMAC4)", string, action);
    cli_print (cli, "\tEnter %s value 5 to %s port 5(EMAC5)", string, action);
    cli_print (cli, "\tEnter %s value 6 to %s port 6(EMAC6)", string, action);
    cli_print (cli, "\tEnter %s value 7 to %s port 7(EMAC7)", string, action);
    cli_print (cli, "\tEnter %s value 8 to %s port 8(EMAC8)", string, action);
    cli_print (cli, "\tEnter %s value 9 to %s port 9(EMAC9)", string, action);
    cli_print (cli, "\tEnter %s value 10 to %s port 10(EMAC10)", string, action);
    cli_print (cli, "\tEnter %s value 11 to %s port 11(EMAC11)", string, action);
    cli_print (cli, "\tEnter %s value 12 to %s port 12(EMAC12)", string, action);
    cli_print (cli, "\tEnter %s value 13 to %s port 13(EMAC13)", string, action);
    cli_print (cli, "\tEnter %s value 14 to %s port 14(EMAC14)", string, action);
    cli_print (cli, "\tEnter %s value 15 to %s port 15(EMAC15)", string, action);
    cli_print (cli, "\tEnter %s value 16 to %s port 16(EMAC16)", string, action);
    cli_print (cli, "\tEnter %s value 17 to %s port 17(HIF)", string, action);
    */
    cli_print (cli, "\tEnter %s value 0x1 to %s port 1 (EMAC1)", string, action);
    cli_print (cli, "\tEnter %s value 0x2 to %s port 2 (EMAC2)", string, action);
    cli_print (cli, "\tEnter %s value 0x3 to %s ports 1 and 2 (EMAC1 and EMAC2)", string, action);
    cli_print (cli, "\tEnter %s value 0x4 to %s port 3 (EMAC3)", string, action);
    cli_print (cli, "\tEnter %s value 0x5 to %s ports 1 and 3 (EMAC1 and EMAC3)", string, action);
    cli_print (cli, "\tEnter %s value 0x6 to %s ports 2 and 3 (EMAC2 and EMAC3)", string, action);
    cli_print (cli, "\tEnter %s value 0x7 to %s ports 1, 2 and 3 (EMAC1, EMAC2 and EMAC3)", string, action);
    cli_print (cli, "\t.......................................................");
    cli_print (cli, "\tEnter %s value 0x10000 to %s port 17 (HIF)", string, action);
    cli_print (cli, "\t.......................................................");
    cli_print (cli, "\tEnter %s value 0x1FFFF to %s all ports", string, action);
	return 0;
}

int get_action_entry(struct cli_def *cli, UINT64 action_entry, int type)
{
  int action = 0;
  if( type == 1){
	action = ((action_entry >> BRENTRY_UCAST_HIT_ACT_START_POS)  & 0x7);
	cli_print(cli, "\tUCAST_HIT_ACTION");
    }else if(type == 2){
	action = ((action_entry >> BRENTRY_MCAST_HIT_ACT_START_POS)  & 0x7);
	cli_print(cli, "\tMCAST_HIT_ACTION");
    }else if(type == 3){
	action = ((action_entry >> BRENTRY_UCAST_MISS_ACT_START_POS) & 0x7);
	cli_print(cli, "\tUCAST_MISS_ACTION");
    }else if(type == 4){
	action = ((action_entry >> BRENTRY_MCAST_MISS_ACT_START_POS) & 0x7);
	cli_print(cli, "\tMCAST_MISS_ACTION");
    }else{
        return CLI_OK;
    }
    switch(action)
    {
	case 0:
		cli_print(cli, "\tForward action is ACT_FORWARD");
		break;
	case 1:
		cli_print(cli, "\tForward action is ACT_FLOOD");
		break;
	case 2:
		cli_print(cli, "\tForward action is ACT_PUNT");
		break;
	case 3:
		cli_print(cli, "\tForward action is ACT_DISCARD");
		break;
	case 4:
		cli_print(cli, "\tForward action is ACT_OVERRIDE");
		break;
	case 5:
		cli_print(cli, "\tForward action is ACT_FWD_MASK");
		break;
	case 6:
		cli_print(cli, "\tForward action is ACT_COS_DISCARD");
		break;
	default:
		cli_print(cli, "\tUnkown action");
		break;
    }
    return 0;
}

int
Switch_Br_Entry_Search_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    UINT64 tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int vlanId, i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;
    UINT64 *action_entry;

    /* switch br_entry_add vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }

    if (strncasecmp(argv[2], "0x", 2) == 0) {
	vlanId = (int)strtol(argv[2], NULL, 16);
    } else {
	vlanId = (int)strtol(argv[2], NULL, 10);
    }

    if((SWITCHAPI_MIN_VLAN_ID > vlanId) ||(vlanId > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_SEARCH;
    pmsg->pcmh_value = vlanId;

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    action_entry = (UINT64 *)buffer;
    tsize = *action_entry;

    if (tsize == -1) {
	cli_print(cli, "Entry not found for vlanId:%d", vlanId);
    } else {
	cli_print(cli, "portlist:0x%llx", (tsize & BRENTRY_FWD_PORT_LIST_MASK) >> BRENTRY_FWD_PORT_LIST_START_POS);
	cli_print(cli, "untaglist:0x%llx", (tsize & BRENTRY_UNTAG_LIST_MASK) >> BRENTRY_UNTAG_LIST_START_POS);

	/* UCAST_HIT_ACTION */
	i = (tsize & BRENTRY_UCAST_HIT_ACT_MASK) >> BRENTRY_UCAST_HIT_ACT_START_POS;
	cli_action_print(cli, "ucasthit", i);

	/* MCAST_HIT_ACTION */
	i = (tsize & BRENTRY_MCAST_HIT_ACT_MASK) >> BRENTRY_MCAST_HIT_ACT_START_POS;
	cli_action_print(cli, "mcasthit", i);

	/* UCAST_MISS_ACTION */
	i = (tsize & BRENTRY_UCAST_MISS_ACT_MASK) >> BRENTRY_UCAST_MISS_ACT_START_POS;
	cli_action_print(cli, "ucastmiss", i);

	/* MCAST_MISS_ACTION */
	i = (tsize & BRENTRY_MCAST_MISS_ACT_MASK) >> BRENTRY_MCAST_MISS_ACT_START_POS;
	cli_action_print(cli, "mcastmiss", i);

	/* MSTP_HIT_ACTION */
	i = (tsize & BRENTRY_MSTP_HIT_ACT_MASK) >> BRENTRY_MSTP_HIT_ACT_START_POS;
	cli_action_print(cli, "mstphit", i);
    }

    free(buffer);

    return (0);
}

/* ---------------------- switch br_entry_add ------------------------ */
int
Switch_Br_Entry_Add_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    switch_br_entry_add_params_t *penrtyadd;
    int tsize = sizeof(pcm_msg_header_t) + sizeof(switch_br_entry_add_params_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    UINT32 fwdPortList, untagList, ucastHitAct, mcastHitAct;
    UINT32 mcastMissAct, mstpAct, ucastMissAct, vlanId;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_add vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strncasecmp(argv[2], "0x", 2) == 0) {
	i = (int)strtol(argv[2], NULL, 16);
    } else {
	i = (int)strtol(argv[2], NULL, 10);
    }
    vlanId = i;

    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList */
    if (argc < 4) {
        cli_print (cli, "Incomplete command. enter fwdPortList");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "fwdPortList      -Enter fwdPortList for forward port list");
        return CLI_OK;
    }
    if (strcmp(argv[3], "fwdPortList")){
        cli_print(cli, "Invalid command. enter fwdPortList");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15]*/
    if (argc < 5) {
	cli_print(cli,"Incomplete command. enter fwdPortList value");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
	cli_portlist_help(cli,"fwdPortList");
        return CLI_OK;
    }
    if (strncasecmp(argv[4], "0x", 2) == 0) {
	i = (int)strtol(argv[4], NULL, 16);
    } else {
	i = (int)strtol(argv[4], NULL, 10);
    }
    if (cli_portlist_chk(cli, i) != CLI_OK) {
	cli_portlist_help(cli,"fwdPortList");
        return CLI_OK;
    }
    fwdPortList = i;

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList */
    if (argc < 6) {
        cli_print (cli, "Incomplete command. enter untagList");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "untagList      -Enter untagList for untag list");
        return CLI_OK;
    }
    if (strcmp(argv[5], "untagList")){
        cli_print(cli, "Invalid command. enter untagList");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] */
    if (argc < 7) {
        cli_print (cli, "Incomplete command. enter untagList value");
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
	cli_portlist_help(cli,"untagList");
        return CLI_OK;
    }
    if (strncasecmp(argv[6], "0x", 2) == 0) {
	i = (int)strtol(argv[6], NULL, 16);
    } else {
	i = (int)strtol(argv[6], NULL, 10);
    }
    if (cli_untaglist_chk(cli, i) != CLI_OK) {
	cli_portlist_help(cli,"untagList");
        return CLI_OK;
    }
    untagList = i;

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct */
    if (argc < 8) {
        cli_print (cli, "Incomplete command. enter ucastHitAct");
        return CLI_OK;
    }
    if (strcmp(argv[7], "?")==0){
        cli_print(cli, "ucastHitAct      -Enter ucastHitAct for unicast hit list");
        return CLI_OK;
    }
    if (strcmp(argv[7], "ucastHitAct")){
        cli_print(cli, "Invalid command. enter ucastHitAct");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6]*/
    if (argc < 9) {
        cli_print (cli, "Incomplete command. Provide ucastHitAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[8], "?")==0){
        cli_print(cli, "Enter ucastHitAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strncasecmp(argv[8], "0x", 2) == 0) {
	i = (int)strtol(argv[8], NULL, 16);
    } else {
	i = (int)strtol(argv[8], NULL, 10);
    }
    if((SWITCHAPI_MIN_UCASTHITACT > i) ||(i > SWITCHAPI_MAX_UCASTHITACT)) {
        cli_print (cli, "Provide ucastHitAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    ucastHitAct = i;
    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct */
    if (argc < 10) {
        cli_print (cli, "Incomplete command. enter mcastHitAct");
        return CLI_OK;
    }
    if (strcmp(argv[9], "?")==0){
        cli_print(cli, "mcastHitAct      -Enter mcastHitAct for multicast hit list");
        return CLI_OK;
    }
    if (strcmp(argv[9], "mcastHitAct")){
        cli_print(cli, "Invalid command. enter mcastHitAct");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6]*/
    if (argc < 11) {
        cli_print (cli, "Incomplete command. Provide mcastHitAct\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[10], "?")==0){
        cli_print(cli, "Enter mcastHitAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strncasecmp(argv[10], "0x", 2) == 0) {
	i = (int)strtol(argv[10], NULL, 16);
    } else {
	i = (int)strtol(argv[10], NULL, 10);
    }
    if((SWITCHAPI_MIN_MCASTHITACT > i) ||(i > SWITCHAPI_MAX_MCASTHITACT)) {
        cli_print (cli, "Provide mcastHitAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    mcastHitAct = i;

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct */
    if (argc < 12) {
        cli_print (cli, "Incomplete command. enter ucastMissAct");
        return CLI_OK;
    }
    if (strcmp(argv[11], "?")==0){
        cli_print(cli, "ucastMissAct      -Enter ucastMissAct for unicast miss list");
        return CLI_OK;
    }
    if (strcmp(argv[11], "ucastMissAct")){
        cli_print(cli, "Invalid command. enter ucastMissAct\n");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6]*/
    if (argc < 13) {
        cli_print (cli, "Incomplete command. Provide ucastMissAct\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[12], "?")==0){
        cli_print(cli, "Enter ucastMissAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strncasecmp(argv[12], "0x", 2) == 0) {
	i = (int)strtol(argv[12], NULL, 16);
    } else {
	i = (int)strtol(argv[12], NULL, 10);
    }
    if((SWITCHAPI_MIN_UCASTMISSACT > i) ||(i > SWITCHAPI_MAX_UCASTMISSACT)) {
        cli_print (cli, "Provide ucastMissAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    ucastMissAct = i;

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct*/
    if (argc < 14) {
        cli_print (cli, "Incomplete command. enter mcastMissAct");
        return CLI_OK;
    }
    if (strcmp(argv[13], "?")==0){
        cli_print(cli, "mcastMissAct    -Enter mcastMissAct for multicast miss list");
        return CLI_OK;
    }
    if (strcmp(argv[13], "mcastMissAct")){
        cli_print(cli, "Invalid command. enter mcastMissAct");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct [0..6]*/
    if (argc < 15) {
        cli_print (cli, "Incomplete command. Provide mcastMissAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[14], "?")==0){
        cli_print(cli, "Enter mcastMissAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strncasecmp(argv[14], "0x", 2) == 0) {
	i = (int)strtol(argv[14], NULL, 16);
    } else {
	i = (int)strtol(argv[14], NULL, 10);
    }
    if((SWITCHAPI_MIN_MCASTMISSACT > i) ||(i > SWITCHAPI_MAX_MCASTMISSACT)) {
        cli_print (cli, "Provide mcastMissAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    mcastMissAct = i;

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct [0..6] mstpAct */
    if (argc < 16) {
        cli_print (cli, "Incomplete command. enter mstpAct");
        return CLI_OK;
    }
    if (strcmp(argv[15], "?")==0){
        cli_print(cli, "mstpAct      -Enter mstpAct for mspt action list");
        return CLI_OK;
    }
    if (strcmp(argv[15], "mstpAct")){
        cli_print(cli, "Invalid command. enter mstpAct");
        return CLI_OK;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct [0..6] mstpAct [0..6]*/
    if (argc < 17) {
        cli_print (cli, "Incomplete command. Provide mstpAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[16], "?")==0){
        cli_print(cli, "Enter mstpAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strncasecmp(argv[16], "0x", 2) == 0) {
	i = (int)strtol(argv[16], NULL, 16);
    } else {
	i = (int)strtol(argv[16], NULL, 10);
    }
    if((SWITCHAPI_MIN_MSTPACT > i) ||(i > SWITCHAPI_MAX_MSTPACT)) {
        cli_print (cli, "Provide mstpAct with in 0 to 6 value\n");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    mstpAct = i;

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_ADD;
    //pmsg->pcmh_value = atoi(argv[2]); /* vlanId */

    penrtyadd = (switch_br_entry_add_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    penrtyadd->swbea_vlanId = vlanId; /* vlanId */
    penrtyadd->swbea_fwdPortList = fwdPortList; /* fwdPortList */
    penrtyadd->swbea_untagList = untagList; /* untagList */
    penrtyadd->swbea_ucastHitAct = ucastHitAct; /* ucastHitAct */
    penrtyadd->swbea_mcastHitAct = mcastHitAct; /* mcastHitAct */
    penrtyadd->swbea_ucastMissAct = ucastMissAct; /* ucastMissAct */
    penrtyadd->swbea_mcastMissAct = mcastMissAct; /* mcastMissAct */
    penrtyadd->swbea_mstpAct = mstpAct; /* mstpAct */

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    free(buffer);
    return (0);


}

int
AddSwitch_Br_Entry_Search_Cmds(struct cli_def *cli) {
    struct cli_command *br_enrty_add;

    /* switch br_entry_search */
    br_enrty_add = cli_register_command(cli, nkCli.nk_switch, "br_entry_search", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tsearch bridge entry");

    /* switch br_entry_search vlanId */
    cli_register_command(cli, br_enrty_add, "vlanId", Switch_Br_Entry_Search_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}

int
AddSwitch_Br_Entry_Add_Cmds(struct cli_def *cli) {
    struct cli_command *br_enrty_add;

    /* switch br_entry_add */
    br_enrty_add = cli_register_command(cli, nkCli.nk_switch, "br_entry_add", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tAdd bridge entry");

    /* switch br_entry_add vlanId */
    cli_register_command(cli, br_enrty_add, "vlanId", Switch_Br_Entry_Add_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}




/* ---------------------- switch br_entry_add_ports Command ------------------------------- */
int
Switch_Br_Entry_Add_Ports_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {
    switch_br_entry_add_ports_params_t *paddports;
    int tsize = sizeof(pcm_msg_header_t) + sizeof(switch_br_entry_add_ports_params_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;
    int untagList = 0, portList = 0;


    /* switch br_entry_add_ports vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "enter vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }

    /* switch br_entry_add_ports vlanId [1..4093] portList */
    if (argc < 4) {
        cli_print (cli, "Incomplete command. enter portList (in hex format)");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "portList      -Enter portList value (in hex format)");
        return CLI_OK;
    }
    if (strcmp(argv[3], "portList")){
        cli_print(cli, "Invalid command. enter portList (in hex format)");
        return CLI_OK;
    }

    /* switch br_entry_add_ports vlanId [1..4093] portList [1..4]*/
    if (argc < 5) {
        cli_print (cli, "Incomplete command\n");
	    portlist_display_add_delete(cli,"portList","add");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli,  "Enter portList with in 0x1 to 0x1FFFF value \n");
	    portlist_display_add_delete(cli,"portList","add");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if((SWITCHAPI_MIN_PORT_LIST > i) ||(i > SWITCHAPI_MAX_PORT_LIST)) {
        cli_print (cli, "Provide PortList with in 0x1 to 0x1FFFF value (in hex format)\n");
	    portlist_display_add_delete(cli,"portList","add");
        return CLI_OK;
    }

    /* switch br_entry_add_ports vlanId [1..4093] portList [1..4] untagList */
    if (argc < 6) {
        cli_print (cli, "Incomplete command. enter untagList (in hex format)");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "untagList     -Enter untagList value (in hex format)");
        return CLI_OK;
    }
    if (strcmp(argv[5], "untagList")){
        cli_print(cli, "Invalid command. enter untagList (in hex format)");
        return CLI_OK;
    }

    /* switch br_entry_add_ports vlanId [1..4093] portList [1..4] untagList [1..4] */
    if (argc < 7) {
        cli_print (cli, "incomplete command Provide untagList \n");
	    portlist_display_add_delete(cli,"Untag portList","add");
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
        cli_print(cli, "enter untagList with in 0x1 to 0x1FFFF value (in hex format)\n");
	    portlist_display_add_delete(cli,"Untag portList","add");
        return CLI_OK;
    }
    i = atoi(argv[6]);
    if((SWITCHAPI_MIN_UNTAG_LIST > i) ||(i > SWITCHAPI_MAX_UNTAG_LIST)) {
        cli_print (cli, "Provide untagList with in 0x1 to 0x1FFFF value\n");
	    portlist_display_add_delete(cli,"Untag portList","add");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_ADD_PORTS;
    pmsg->pcmh_value = atoi(argv[2]); /* hw_type */

    paddports = (switch_br_entry_add_ports_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    untagList = strtol(argv[6], NULL, 16);
    portList = strtol(argv[4], NULL, 16);

    paddports->swbeap_vlanId = atoi(argv[2]); /* vlanId */
    cli_print(cli, "vlanId = %d, portList = 0x%x, untagList = 0x%x", paddports->swbeap_vlanId, portList, untagList);
    /*Forward list*/

    paddports->swbeap_portList = portList & SWITCHAPI_MAX_PORT_LIST;
    paddports->swbeap_untagList = untagList & SWITCHAPI_MAX_UNTAG_LIST;

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
    }

    free(buffer);
    return (0);
}

int
AddSwitch_Br_Entry_Add_Ports_Cmds (struct cli_def *cli) {

    struct cli_command *br_entry_add_ports;

    /* switch br_entry_add_ports */
    br_entry_add_ports = cli_register_command(cli, nkCli.nk_switch, "br_entry_add_ports", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tAdd bridge entry portlist");

    /* switch br_entry_add_ports vlanId */
    cli_register_command(cli, br_entry_add_ports, "vlanId", Switch_Br_Entry_Add_Ports_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}

/* ---------------------- switch br_entry_portlist_get Command ------------------------------- */
int
Switch_Br_Entry_Portlist_Get_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i, *action_entry;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_portlist_get vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value (in dec format) ");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value (in dec format) ");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value (in dec format) ");
        return CLI_OK;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_PORTLIST_GET;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */
    cli_print(cli, "\tvlanId = %d", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "Ioctl error, Unable to obtain necessary data \n");
        return (0);
    }


    action_entry = (int *)buffer;
    cli_print_portlist(cli, "FORWARD PORT", (*action_entry));
    free(buffer);
    return (0);

}


int
AddSwitch_Br_Entry_Portlist_Get_Cmds (struct cli_def *cli) {

    struct cli_command *br_enrty_portlist_get;

    /* switch br_entry_portlist_get */
    br_enrty_portlist_get = cli_register_command(cli, nkCli.nk_switch, "br_entry_portlist_get", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tGet bridge entry portlist");

    /* switch br_entry_portlist_get vlanId */
    cli_register_command(cli, br_enrty_portlist_get, "vlanId", Switch_Br_Entry_Portlist_Get_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}


/* ---------------------- switch br_entry_untaglist_get Command ------------------------------- */
int
Switch_Br_Entry_Untaglist_Get_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i, *action_entry;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_untaglist_get vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value ");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_UNTAGLIST_GET;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */
    cli_print(cli, "\tvlanId = %d", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    action_entry = (int *)buffer;
    cli_print(cli, "\nUntagList: 0x%x\n", *action_entry);
    cli_print_portlist(cli, "PORT: ", *action_entry);

/*
    cli_print(cli, "\tPorts:%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
                                            (( (*action_entry >> 0) & 1)?"EMAC1":""),
                                            (( (*action_entry >> 1) & 1)?"EMAC2":""),
                                            (( (*action_entry >> 2) & 1)?"EMAC3":""),
                                            (( (*action_entry >> 3) & 1)?"EMAC4":""),
                                            (( (*action_entry >> 4) & 1)?"EMAC5":""),
                                            (( (*action_entry >> 5) & 1)?"EMAC6":""),
                                            (( (*action_entry >> 6) & 1)?"EMAC7":""),
                                            (( (*action_entry >> 7) & 1)?"EMAC8":""),
                                            (( (*action_entry >> 8) & 1)?"EMAC9":""),
                                            (( (*action_entry >> 9) & 1)?"EMAC10":""),
                                            (( (*action_entry >> 10) & 1)?"EMAC11":""),
                                            (( (*action_entry >> 11) & 1)?"EMAC12":""),
                                            (( (*action_entry >> 12) & 1)?"EMAC13":""),
                                            (( (*action_entry >> 13) & 1)?"EMAC14":""),
                                            (( (*action_entry >> 14) & 1)?"EMAC15":""),
                                            (( (*action_entry >> 15) & 1)?"EMAC16":""),
                                            (( (*action_entry >> 16) & 1)?"HIF":""));
*/
    free(buffer);
    return (0);

}


int
AddSwitch_Br_Entry_Untaglist_Get_Cmds (struct cli_def *cli) {

    struct cli_command *br_enrty_untaglist_get;

    /* switch br_entry_untaglist_get */
    br_enrty_untaglist_get = cli_register_command(cli, nkCli.nk_switch, "br_entry_untaglist_get", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tGet bridge entry untaglist");

    /* switch br_entry_untaglist_get vlanId */
    cli_register_command(cli, br_enrty_untaglist_get, "vlanId", Switch_Br_Entry_Untaglist_Get_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}


/* ---------------------- switch br_entry_port_tag_chg Command ------------------------------- */
int
Switch_Br_Entry_Port_Tag_Chg_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    switch_br_entry_port_tag_chg_params_t *ptagchg;
    int tsize = sizeof(pcm_msg_header_t) + sizeof(switch_br_entry_port_tag_chg_params_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_port_tag_chg vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    
    ptagchg = (switch_br_entry_port_tag_chg_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    ptagchg->ptchg_vlanId = i = atoi(argv[2]);

    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }

    /* switch br_entry_port_tag_chg vlanId [1..4093] portlist */
    if (argc < 4) {
        cli_print (cli, "Incomplete command -Enter portList");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "portList      -Enter  portList (in hex format)");
        return CLI_OK;
    }
    if (strcmp(argv[3], "portList")){
        cli_print(cli, "Invalid command. enter portList");
        return CLI_OK;
    }

    /* switch br_entry_port_tag_chg vlanId [1..4093] portlist [0..15]*/
    if (argc < 5) {
        cli_print (cli, "Incomplete command. Provide portList value");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
	    cli_portlist_help(cli,"portList");
        return CLI_OK;
    }

    if (strncasecmp(argv[4], "0x", 2) == 0) {
	    ptagchg->ptchg_portList = i = (int)strtol(argv[4], NULL, 16);
    } else {
	    ptagchg->ptchg_portList = i = (int)strtol(argv[4], NULL, 10);
    }

    if(cli_portlist_chk(cli, i) != CLI_OK) {
	cli_portlist_help(cli,"portList");
	return CLI_OK;
    }

    /* switch br_entry_port_tag_chg vlanId [1..4093] portlist [0..15] tagchange_list */
    if (argc < 6) {
        cli_print (cli, "Incomplete command  -Enter tagchange_list");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "tagchange_list      -Enter change tag list");
        return CLI_OK;
    }
    if (strcmp(argv[5], "tagchange_list")){
        cli_print(cli, "Invalid command  -Enter Tag change list");
        return CLI_OK;
    }

    /* switch br_entry_port_tag_chg vlanId [1..4093] portlist [0..15] tagchange_list [0..15] */
    if (argc < 7) {
	cli_print(cli,"Incomplete command -Enter tagchange_list val");
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
	cli_portlist_help(cli,"tagchange_list");
        return CLI_OK;
    }

    //i = atoi(argv[6]);

    if (strncasecmp(argv[6], "0x", 2) == 0) {
	   ptagchg->ptchg_tagValue = i = (int)strtol(argv[6], NULL, 16);
    } else {
	   ptagchg->ptchg_tagValue = i = (int)strtol(argv[6], NULL, 10);
    }
    if(cli_untaglist_chk(cli, i) != CLI_OK) {
	cli_portlist_help(cli,"tagchange_list");
	return CLI_OK;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_PORT_TAG_CHG;
    //pmsg->pcmh_value = atoi(argv[2]); /* hw_type */

//    ptagchg = (switch_br_entry_port_tag_chg_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

//    ptagchg->ptchg_vlanId = atoi(argv[2]); /* vlanId */
//    ptagchg->ptchg_portList = atoi(argv[4]); /* portlist */
//    ptagchg->ptchg_tagValue = atoi(argv[6]); /* tagchange_list */

    cli_print(cli, "\tvlanId = %d, portList = 0x%x, tagchange_list = 0x%x", ptagchg->ptchg_vlanId, ptagchg->ptchg_portList, ptagchg->ptchg_tagValue);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    free(buffer);
    return (0);

}

int
AddSwitch_Br_Entry_Port_Tag_Chg_Cmds (struct cli_def *cli) {

    struct cli_command *br_entry_port_tag_chg;

    /* switch br_entry_port_tag_chg */
    br_entry_port_tag_chg = cli_register_command(cli, nkCli.nk_switch, "br_entry_port_tag_chg", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tChange bridge entry port tag");

    /* switch br_entry_port_tag_chg vlanId */
    cli_register_command(cli, br_entry_port_tag_chg, "vlanId", Switch_Br_Entry_Port_Tag_Chg_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}


/* ---------------------- switch br_entry_fwd_action_get Command ------------------------------- */
int
Switch_Br_Entry_Fwd_Action_Get_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i, *action_entry;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_fwd_action_get vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }

  /* switch br_entry_fwd_action_get vlanId [1..4093] actionType*/
    if (argc < 4) {
        cli_print (cli, "Incomplete command. enter actionType");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "actionType     -Enter actionType");

        return CLI_OK;
    }
    if (strcmp(argv[3], "actionType")){
        cli_print(cli, "Invalid command. enter actionType");
        return CLI_OK;
    }
    /* switch br_entry_fwd_action_get vlanId [1..4093] actionType [1..4]*/
    if (argc < 5) {
        cli_print (cli, "Incomplete command. Provide actionType with in 1 to 4 value");
        cli_print (cli, "\tEnter parameter value for UCAST_HIT_ACTION   1");
        cli_print (cli, "\tEnter parameter value for MCAST_HIT_ACTION   2");
        cli_print (cli, "\tEnter parameter value for UCAST_MISS_ACTION  3");
        cli_print (cli, "\tEnter parameter value for MCAST_MISS_ACTION  4");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter actionType with in 1 to 4 value ");
        cli_print (cli, "\tEnter parameter value for UCAST_HIT_ACTION   1");
        cli_print (cli, "\tEnter parameter value for MCAST_HIT_ACTION   2");
        cli_print (cli, "\tEnter parameter value for UCAST_MISS_ACTION  3");
        cli_print (cli, "\tEnter parameter value for MCAST_MISS_ACTION  4");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if((SWITCHAPI_MIN_ACTION_TYPE > i) ||(i > SWITCHAPI_MAX_ACTION_TYPE)) {
        cli_print (cli, "Provide actionType with in 1 to 4 value");
        cli_print (cli, "\tEnter parameter value for UCAST_HIT_ACTION   1");
        cli_print (cli, "\tEnter parameter value for MCAST_HIT_ACTION   2");
        cli_print (cli, "\tEnter parameter value for UCAST_MISS_ACTION  3");
        cli_print (cli, "\tEnter parameter value for MCAST_MISS_ACTION  4");
        return CLI_OK;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_FWD_ACTION_GET;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */
    cli_print(cli, "\tvlanId = %d", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    action_entry = (int *)buffer;
    cli_print(cli, "\tActionType: 0x%X", *action_entry);
    get_action_entry(cli,*action_entry,i);

    free(buffer);
    return (0);

}


int
AddSwitch_Br_Entry_Fwd_Action_Get_Cmds (struct cli_def *cli) {

    struct cli_command *br_entry_fwd_action_get;

    /* switch br_entry_fwd_action_get */
    br_entry_fwd_action_get = cli_register_command(cli, nkCli.nk_switch, "br_entry_fwd_action_get", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tGet bridge entry untaglist");

    /* switch br_entry_fwd_action_get vlanId */
    cli_register_command(cli, br_entry_fwd_action_get, "vlanId", Switch_Br_Entry_Fwd_Action_Get_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}


/* ---------------------- switch port_config_get Command ------------------------------- */
int
Switch_Port_Config_Get_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t) + sizeof(struct port_s);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch port_config_get portNo [0..16] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide portNo with in %d to %d value (in dec format)", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter port number with in %d to %d value (in dec format)", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_PORT_NO > i) ||(i > SWITCHAPI_MAX_PORT_NO)) {
        cli_print (cli, "Provide port number with in %d to %d value (in dec format)", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
        return CLI_OK;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_PORT_CONFIG_GET;
    pmsg->pcmh_value = atoi(argv[2]); /* portNo */
    cli_print(cli, "\tportNo = %d %s", pmsg->pcmh_value, (pmsg->pcmh_value == 17)?"(HOST)":"" );
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize))
    {
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    struct port_s *pPortInfo;
    pPortInfo = (struct port_s *)buffer;

    cli_print(cli, "\tshutdown = %d\n\ttpid = 0x%x\n\taft = %d\n\tfallback_bd_id = %d\n\tblock_state = %d\n\ttrusted = %d\n\ttcsel_table = %x\n\tpcp2tc_table = %x\n\tdef_cfi = %x\n\tdef_pri = %x\n\tdef_tc = %x\n\ttc2cos_table = %x\n\tpindex = %x\n\tcsr_untag_from_btable = %x",
                    pPortInfo->shutdown,
                    pPortInfo->tpid,
                    pPortInfo->aft,
                    pPortInfo->fallback_bd_id,
                    pPortInfo->block_state,
                    pPortInfo->trusted,
                    pPortInfo->tcsel_table,
                    pPortInfo->pcp2tc_table,
                    pPortInfo->def_cfi,
                    pPortInfo->def_pri,
                    pPortInfo->def_tc,
                    pPortInfo->tc2cos_table,
                    pPortInfo->pindex,
                    pPortInfo->csr_untag_from_btable);

    free(buffer);
    return (0);
}


int
AddSwitch_Port_Config_Get_Cmds (struct cli_def *cli) {

    struct cli_command *port_config_get;

    /* switch port_config_get */
    port_config_get = cli_register_command(cli, nkCli.nk_switch, "port_config_get", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tGet port configuration");

    /* switch port_config_get portNo */
    cli_register_command(cli, port_config_get, "portNo", Switch_Port_Config_Get_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter portNo ");

    return 0;

}


unsigned char* get_action_name(unsigned int value){

    unsigned char *ptr;

    ptr = (unsigned char*)"Invalid value";

    switch (value & 7){
        case ACT_FORWARD:
            ptr = (unsigned char*)"ACT_FORWARD";
            break;
        case ACT_FLOOD:
            ptr = (unsigned char*)"ACT_FLOOD";
            break;
        case ACT_PUNT:
            ptr = (unsigned char*)"ACT_PUNT";
            break;
        case ACT_DISCARD:
            ptr = (unsigned char*)"ACT_DISCARD";
            break;
        case ACT_OVERRIDE:
            ptr = (unsigned char*)"ACT_OVERRIDE";
            break;
        case ACT_FWD_MASK:
            ptr = (unsigned char*)"ACT_FWD_MASK";
            break;
        case ACT_COS_DISCARD:
            ptr = (unsigned char*)"ACT_COS_DISCARD";
            break;
    }

    return ptr;
}


/* ---------------------- switch global_br_entry_config_get Command ------------------------------- */

int
Switch_Global_Br_Entry_Config_Get_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t) + sizeof(struct global_s);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;


    pmsg->pcmh_type = PCM_MSG_SWITCH_GLOBAL_BR_ENTRY_CONFIG_GET;
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    struct global_s *pGlobal_br_entry;
    pGlobal_br_entry = (struct global_s *)buffer;



    cli_print(cli, "\tl2_special_punt_enable = %d\n\tforward_list = 0x%X\n\tuntag_list = 0x%X",
                    pGlobal_br_entry->l2_special_punt_enable,
                    pGlobal_br_entry->fallback_bd_entry.forward_list,
                    pGlobal_br_entry->fallback_bd_entry.untag_list
                    );


    cli_print(cli, "\tucast_hit_action = %s", get_action_name(pGlobal_br_entry->fallback_bd_entry.ucast_hit_action) );
    cli_print(cli, "\tmcast_hit_action = %s", get_action_name(pGlobal_br_entry->fallback_bd_entry.mcast_hit_action) );
    cli_print(cli, "\tucast_miss_action = %s", get_action_name(pGlobal_br_entry->fallback_bd_entry.ucast_miss_action) );
    cli_print(cli, "\tmcast_miss_action = %s", get_action_name(pGlobal_br_entry->fallback_bd_entry.mcast_miss_action) );
    cli_print(cli, "\tmstp_action = %s", get_action_name(pGlobal_br_entry->fallback_bd_entry.mstp_action) );

    memset(pGlobal_br_entry, 0, sizeof(struct global_s));
    free(buffer);
    return (0);

}


int
AddSwitch_Global_Br_Entry_Config_Get_Cmds (struct cli_def *cli) {

    /* switch global_br_entry_config_get */
    cli_register_command(cli, nkCli.nk_switch, "global_br_entry_config_get", Switch_Global_Br_Entry_Config_Get_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tGet global bridge entry configuration");

    return 0;

}


/* ---------------------- switch br_entry_fwd_action_chg Command ------------------------------- */
int
Switch_Br_Entry_Fwd_Action_Chg_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {
    switch_br_entry_farward_action_chg_params_t *pfachg;
    int tsize = sizeof(pcm_msg_header_t) + sizeof(switch_br_entry_farward_action_chg_params_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_fwd_action_chg vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command  -Provide vlanId with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }

    /* switch br_entry_fwd_action_chg vlanId [1..4093] field */
    if (argc < 4) {
        cli_print (cli, "Incomplete command. enter field");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "field      -Enter field type (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[3], "field")){
        cli_print(cli, "Invalid command  -Enter field");
        return CLI_OK;
    }

    /* switch br_entry_fwd_action_chg vlanId [1..4093] field [0..4]*/
    if (argc < 5) {
        cli_print (cli, "Incomplete command    -Provide field with in 0 to 4 value \n\tBR_ENTRY_UCAST_HIT\t0 \n\tBR_ENTRY_MCAST_HIT\t1\n\tBR_ENTRY_UCAST_MISS\t2 \n\tBR_ENTRY_MCAST_MISS\t3\n\tBR_ENTRY_MSTP\t4\n");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print (cli, "Incomplete command    -Provide field with in 0 to 4 value \n\tBR_ENTRY_UCAST_HIT\t0 \n\tBR_ENTRY_MCAST_HIT\t1\n\tBR_ENTRY_UCAST_MISS\t2 \n\tBR_ENTRY_MCAST_MISS\t3\n\tBR_ENTRY_MSTP\t4\n");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if((SWITCHAPI_MIN_FIELD > i) ||(i > SWITCHAPI_MAX_FIELD)) {
        cli_print (cli, "Incomplete command    -Provide field with in 0 to 4 value \n\tBR_ENTRY_UCAST_HIT\t0 \n\tBR_ENTRY_MCAST_HIT\t1\n\tBR_ENTRY_UCAST_MISS\t2 \n\tBR_ENTRY_MCAST_MISS\t3\n\tBR_ENTRY_MSTP\t4\n");
        return CLI_OK;
    }

    /* switch br_entry_fwd_action_chg vlanId [1..4093] field [0..6] value */
    if (argc < 6) {
        cli_print (cli, "Incomplete command  -Enter action filed value");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "value      -Enter action filed value (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[5], "value")){
        cli_print(cli, "Invalid command  -Enter action filed value");
        return CLI_OK;
    }


    /* switch br_entry_fwd_action_chg vlanId [1..4093] field [0..4] value [0..6] */
    if (argc < 7) {
        cli_print (cli, "Incomplete command. Provide action filed value with in 0 to 6");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
        cli_print(cli, "Enter action filed value with in 0 to 6 (in dec format)");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    i = atoi(argv[6]);
    if((SWITCHAPI_MIN_ACTION_FIELD_TYPE > i) ||(i > SWITCHAPI_MAX_ACTION_FIELD_TYPE)) {
        cli_print (cli, "Provide action filed value with in 0 to 6");
	    cli_action_field_help(cli);
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_FWD_ACTION_CHANGE;

    pfachg = (switch_br_entry_farward_action_chg_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    pfachg->pfachg_vlanId = atoi(argv[2]); /* vlanId */
    pfachg->pfachg_field = atoi(argv[4]); /* field */
    pfachg->pfachg_value = atoi(argv[6]); /* value */

    cli_print(cli, "vlanId = %d, Action Field Type = %d, Action Filed Value = %d", pfachg->pfachg_vlanId, pfachg->pfachg_field, pfachg->pfachg_value );
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    free(buffer);
    return (0);

}

int
AddSwitch_Br_Entry_Fwd_Action_Chg_Cmds (struct cli_def *cli) {

    struct cli_command *br_entry_fwd_action_chg;

    /* switch br_entry_fwd_action_chg */
    br_entry_fwd_action_chg = cli_register_command(cli, nkCli.nk_switch, "br_entry_fwd_action_chg", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tChange bridge entry farward action");

    /* switch br_entry_fwd_action_chg vlanId */
    cli_register_command(cli, br_entry_fwd_action_chg, "vlanId", Switch_Br_Entry_Fwd_Action_Chg_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return 0;
}

/* ----------------------- Private vlan configuration ------------------------------ */
int
Switch_Pvlan_Config_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {


    int port_num, port_type, tsize = sizeof(pcm_msg_header_t) + sizeof(struct port_s);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    pcm_msg_header_t *pmsg;
    struct port_s *pPort;
    pmsg = (pcm_msg_header_t *)buffer;
    int index, pvlan, svlan[FP_MAX_SWITCH_PORTS], num_svlan;

    /* switch port_config portNo [0..3] */
    if (argc < 3) {
	   //cli_print (cli, "Incomplete command Provide portNo with in 0 to 3 value");
       cli_print (cli, "Incomplete command Provide portNo with in 1 to 17 value");
	   return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        //cli_print(cli, "Enter port number with in 0 to 3 value ");
        cli_print(cli, "Enter port number with in 1 to 17 value ");
        return CLI_OK;
    }
    port_num = atoi(argv[2]);

    if((SWITCHAPI_MIN_PORT_NO > port_num) ||(port_num > SWITCHAPI_MAX_PORT_NO)) {
	   //cli_print (cli, "Provide port number with in 0 to 3 value");
       cli_print (cli, "Provide port number with in 1 to 17 value");
	   return CLI_OK;
    }

    if (argc < 4) {
	   cli_print (cli, "Incomplete command  -Enter port_type");
	   return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
	   cli_print(cli, "port_type      -Enter the port type");
	   return CLI_OK;
    }
    if (strcmp(argv[3], "port_type")){
	   cli_print(cli, "Invalid command -Enter port_type");
	   return CLI_OK;
    }
    if (argc < 5) {
	   cli_print(cli,"Incomplete command  Provide port_type ");
	   cli_print(cli,"\tport_type isolated");
	   cli_print(cli,"\tport_type community");
	   cli_print(cli,"\tport_type promiscuous");
	   cli_print(cli,"\tport_type inter-switch");
    	return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
	   cli_print(cli,"Enter port_type: isolated/community/promiscuous/inter-switch");
	return CLI_OK;
    }
    if (!strcmp(argv[4], "isolated")) {
	   port_type = 0;
    } else if (!strcmp(argv[4], "community")) {
	   port_type = 1;
    } else if (!strcmp(argv[4], "promiscuous")) {
	   port_type = 2;
    } else if (!strcmp(argv[4], "inter-switch")) {
       port_type = 3;
    } else {
	   cli_print(cli,"Enter correct port_type: isolated/community/promiscuous/inter-switch");
	   return CLI_OK;
    }

    if (argc < 6) {
	   cli_print (cli, "Incomplete command  -Enter primary_vlan");
	   return CLI_OK;
    }

    if (strcmp(argv[5], "?")==0){
	   cli_print(cli, "primary_vlan      -Enter primary_vlan");
	   return CLI_OK;
    }

    if (strcmp(argv[5], "primary_vlan")){
	   cli_print(cli, "Invalid command -Enter primary_vlan");
	   return CLI_OK;
    }

    if (argc < 7) {
	   cli_print (cli, "Incomplete command Provide primary_vlan");
	   return CLI_OK;
    }

    if (strcmp(argv[6], "?")==0){
	   cli_print(cli,"Enter primary vlan id");
	   return CLI_OK;
    }
    pvlan = atoi(argv[6]);

    if (argc < 8) {
	   cli_print (cli, "Incomplete command  -Enter secondary_vlan");
	   return CLI_OK;
    }

    if (strcmp(argv[7], "?")==0){
	   cli_print(cli, "secondary_vlan      -Enter secondary_vlan");
	   return CLI_OK;
    }

    if (strcmp(argv[7], "secondary_vlan")){
	   cli_print(cli, "Invalid command -Enter secondary_vlan");
	   return CLI_OK;
    }

    if (argc < 9) {
	   cli_print (cli, "Incomplete command Provide secondary_vlan id");
	   return CLI_OK;
    }

    if (strcmp(argv[8], "?")==0){
	   cli_print(cli,"Enter secondary vlan id for isolated/community port");
	   cli_print(cli,"Enter secondary vlan ids seperated by spaces for promiscuous/inter-switch port");
	   return CLI_OK;
    }

    num_svlan = argc - 8;
    if (num_svlan > FP_MAX_SWITCH_PORTS) {
	   cli_print (cli, "number of secondary vlan cannot be greater than the max switch ports");
	   return CLI_OK;
    }

    for (index = 0; index < num_svlan; index++)
    	svlan[index] = atoi(argv[8+index]);

#if 0
    printf("No. of arguments: %d ", argc);
    printf("port_type is: %d", port_type);
    printf("pvlan is: %d ", pvlan);
    printf("num svlan is: %d", num_svlan);

    for (index = 0; index < num_svlan; index++)
    	printf("\t%d", svlan[index]);

    printf("\n");
#endif



    pmsg->pcmh_type = PCM_MSG_SWITCH_PVLAN_CONFIG;
    pmsg->pcmh_value = atoi(argv[2]); /* portNo */

    pPort = (struct port_s *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    pPort->pvlan_enable = 1;
    pPort->pvlan_type = port_type;
    pPort->pvlan_pri = pvlan;
    pPort->num_sec = num_svlan;

    for (index = 0; index < num_svlan; index++){
	   pPort->pvlan_sec[index] = svlan[index];
    }

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
	   fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
	   return (0);
    }

    free(buffer);

    return CLI_OK;

}


/* ----------------------- Private vlan Remove configuration ------------------------------ */
int
Switch_Pvlan_Del_Config_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {


    int port_num, port_type, tsize = sizeof(pcm_msg_header_t) + sizeof(struct port_s);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    pcm_msg_header_t *pmsg;
    struct port_s *pPort;
    pmsg = (pcm_msg_header_t *)buffer;
    int index, pvlan, svlan[FP_MAX_SWITCH_PORTS], num_svlan;

    /* switch port_config portNo [0..3] */
    if (argc < 3) {
	cli_print (cli, "Incomplete command Provide portNo with in 0 to 3 value");
	return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter port number with in 0 to 3 value ");
        return CLI_OK;
    }
    port_num = atoi(argv[2]);
    if((SWITCHAPI_MIN_PORT_NO > port_num) ||(port_num > SWITCHAPI_MAX_PORT_NO)) {
	cli_print (cli, "Provide port number with in 0 to 3 value");
	return CLI_OK;
    }

    if (argc < 4) {
	cli_print (cli, "Incomplete command  -Enter port_type");
	return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
	cli_print(cli, "port_type      -Enter the port type");
	return CLI_OK;
    }
    if (strcmp(argv[3], "port_type")){
	cli_print(cli, "Invalid command -Enter port_type");
	return CLI_OK;
    }
    if (argc < 5) {
	cli_print(cli,"Incomplete command  Provide port_type ");
	cli_print(cli,"\tport_type isolated");
	cli_print(cli,"\tport_type community");
	cli_print(cli,"\tport_type promiscuous");
	cli_print(cli,"\tport_type inter-switch");
    	return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
	cli_print(cli,"Enter port_type: isolated/community/promiscuous/inter-switch");
	return CLI_OK;
    }
    if (!strcmp(argv[4], "isolated")) {
	port_type = 0;
    } else if (!strcmp(argv[4], "community")) {
	port_type = 1;
    } else if (!strcmp(argv[4], "promiscuous")) {
	port_type = 2;
    } else if (!strcmp(argv[4], "inter-switch")) {
        port_type = 3;
    } else {
	cli_print(cli,"Enter correct port_type: isolated/community/promiscuous/inter-switch");
	return CLI_OK;
    }

    if (argc < 6) {
	cli_print (cli, "Incomplete command  -Enter primary_vlan");
	return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
	cli_print(cli, "primary_vlan      -Enter primary_vlan");
	return CLI_OK;
    }
    if (strcmp(argv[5], "primary_vlan")){
	cli_print(cli, "Invalid command -Enter primary_vlan");
	return CLI_OK;
    }
    if (argc < 7) {
	cli_print (cli, "Incomplete command Provide primary_vlan");
	return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
	cli_print(cli,"Enter primary vlan id");
	return CLI_OK;
    }
    pvlan = atoi(argv[6]);

    if (argc < 8) {
	cli_print (cli, "Incomplete command  -Enter secondary_vlan");
	return CLI_OK;
    }
    if (strcmp(argv[7], "?")==0){
	cli_print(cli, "secondary_vlan      -Enter secondary_vlan");
	return CLI_OK;
    }
    if (strcmp(argv[7], "secondary_vlan")){
	cli_print(cli, "Invalid command -Enter secondary_vlan");
	return CLI_OK;
    }
    if (argc < 9) {
	cli_print (cli, "Incomplete command Provide secondary_vlan id");
	return CLI_OK;
    }
    if (strcmp(argv[8], "?")==0){
	cli_print(cli,"Enter secondary vlan id for isolated/community port");
	cli_print(cli,"Enter secondary vlan ids seperated by spaces for promiscuous/inter-switch port");
	return CLI_OK;
    }

    num_svlan = argc - 8;
    if (num_svlan > FP_MAX_SWITCH_PORTS) {
	cli_print (cli, "number of secondary vlan cannot be greater than the max switch ports");
	return CLI_OK;
    }

    for (index = 0; index < num_svlan; index++)
    	svlan[index] = atoi(argv[8+index]);

#if 0
    printf("No. of arguments: %d ", argc);
    printf("port_type is: %d", port_type);
    printf("pvlan is: %d ", pvlan);
    printf("num svlan is: %d", num_svlan);

    for (index = 0; index < num_svlan; index++)
    	printf("\t%d", svlan[index]);

    printf("\n");
#endif



    pmsg->pcmh_type = PCM_MSG_SWITCH_PVLAN_DEL_CONFIG;
    pmsg->pcmh_value = atoi(argv[2]); /* portNo */

    pPort = (struct port_s *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    pPort->pvlan_enable = 1;
    pPort->pvlan_type = port_type;
    pPort->pvlan_pri = pvlan;
    pPort->num_sec = num_svlan;

    for (index = 0; index < num_svlan; index++)
	pPort->pvlan_sec[index] = svlan[index];

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
	fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
	return (0);
    }

    free(buffer);

    return CLI_OK;

}

/* ---------------------- switch port_config Command ------------------------------- */
int
Switch_Port_Config_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t) + sizeof(struct port_s);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    struct port_s *pPort;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch port_config portNo [1..17] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command Provide portNo with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter port number with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_PORT_NO > i) ||(i > SWITCHAPI_MAX_PORT_NO)) {
        cli_print (cli, "Provide port number with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown */
    if (argc < 4) {
        cli_print (cli, "Incomplete command  -Enter shutdown");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "shutdown      -Enter shutdown");
        return CLI_OK;
    }
    if (strcmp(argv[3], "shutdown")){
        cli_print(cli, "Invalid command -Enter shutdown");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1]*/
    if (argc < 5) {
        cli_print(cli,"Incomplete command  Provide shutdown value (defaule value 0)");
	cli_print(cli,"\tShutdown Disable\t0");
        cli_print(cli,"\tShutdown Enable \t1");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli,"Enter shutdown value (defaule value 0)");
	cli_print(cli,"\tShutdown Disable\t0");
        cli_print(cli,"\tShutdown Enable \t1");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if((0 > i) ||(i > 1)) {
        cli_print(cli,"Provide shutdown value (defaule value 0)");
	cli_print(cli,"\tShutdown Disable\t0");
        cli_print(cli,"\tShutdown Enable \t1");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid */
    if (argc < 6) {
        cli_print (cli, "Incomplete command -Enter tpid value");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "tpid      -Enter tpid value");
        return CLI_OK;
    }
    if (strcmp(argv[5], "tpid")){
        cli_print(cli, "Invalid command -Enter tpid value");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] */
    if (argc < 7) {
        cli_print (cli, "Incomplete command  Provide tpid value in decimal (default value 33024)");
        cli_print (cli, "\tVLAN_TAGGED_FRAME      \t0x8100->33024");
        //cli_print (cli, "\tPROVIDER_BRIDGING_FRAME\t0x88a8->34984");
        //cli_print (cli, "\tQinQ_9100_FRAME        \t0x9100->37120");
        //cli_print (cli, "\tQinQ_9200_FRAME        \t0x9200->37376");
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
        cli_print(cli, "Enter tpid value in decimal (default value 33024)");
        cli_print (cli, "\tVLAN_TAGGED_FRAME      \t0x8100->33024");
        //cli_print (cli, "\tPROVIDER_BRIDGING_FRAME\t0x88a8->34984");
        //cli_print (cli, "\tQinQ_9100_FRAME        \t0x9100->37120");
        //cli_print (cli, "\tQinQ_9200_FRAME        \t0x9200->37376");
        return CLI_OK;
    }
    i = atoi(argv[6]);
    if(!( (i == 0x8100 ) /*||(i == 0x88a8)||(i == 0x9100)||(i == 0x9200)*/ )) {
        cli_print (cli, "Provide tpid value in decimal (default value 33024)");
        cli_print (cli, "\tVLAN_TAGGED_FRAME      \t0x8100->33024");
        //cli_print (cli, "\tPROVIDER_BRIDGING_FRAME\t0x88a8->34984");
        //cli_print (cli, "\tQinQ_9100_FRAME        \t0x9100->37120");
        //cli_print (cli, "\tQinQ_9200_FRAME        \t0x9200->37376");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] aft */
    if (argc < 8) {
        cli_print (cli, "Incomplete command   -Enter aft value");
        return CLI_OK;
    }
    if (strcmp(argv[7], "?")==0){
        cli_print(cli, "aft      -Enter (aft) acceptable frame type");
        return CLI_OK;
    }
    if (strcmp(argv[7], "aft")){
        cli_print(cli, "Invalid command  -Enter aft");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] aft [0..2]*/
    if (argc < 9) {
        cli_print (cli, "Incomplete command  Provide aft value (default value 0)");
        cli_print (cli, "\tANY_TAGGING  \t0");
        cli_print (cli, "\tTAGGED_ONLY  \t1");
        cli_print (cli, "\tUNTAGGED_ONLY\t2");
        return CLI_OK;
    }
    if (strcmp(argv[8], "?")==0){
        cli_print(cli, "Enter aft value (default value 0)");
        cli_print (cli, "\tANY_TAGGING  \t0");
        cli_print (cli, "\tTAGGED_ONLY  \t1");
        cli_print (cli, "\tUNTAGGED_ONLY\t2");
        return CLI_OK;
    }
    i = atoi(argv[8]);
    if((0 > i) ||(i > 2)) {
        cli_print (cli, "Provide aft value (default value 0)");
        cli_print (cli, "\tANY_TAGGING  \t0");
        cli_print (cli, "\tTAGGED_ONLY  \t1");
        cli_print (cli, "\tUNTAGGED_ONLY\t2");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] aft [0..1] fallback_bd_id */
    if (argc < 10) {
        cli_print (cli, "Incomplete command  -Enter fallback_bd_id");
        return CLI_OK;
    }
    if (strcmp(argv[9], "?")==0){
        cli_print(cli, "fallback_bd_id      -Enter fallback_bd_id for fallback bridge domain");
        return CLI_OK;
    }
    if (strcmp(argv[9], "fallback_bd_id")){
        cli_print(cli, "Invalid command    -Enter fallback_bd_id");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] aft [0..1] fallback_bd_id [0..5]*/
    if (argc < 11) {
        cli_print (cli, "Incomplete command  Provide fallback_bd_id with in 1 to 4093 value (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[10], "?")==0){
        cli_print(cli, "Enter fallback_bd_id with in 1 to 4093 value ");
        return CLI_OK;
    }
    i = atoi(argv[10]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide fallback_bd_id with in 1 to 4093 value");
        return CLI_OK;
    }

    /* switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] aft [0..1] fallback_bd_id [0..5] block_state */
    if (argc < 12) {
        cli_print (cli, "Incomplete command  -Enter block_state");
        return CLI_OK;
    }
    if (strcmp(argv[11], "?")==0){
        cli_print(cli, "block_state      -Enter block_state for block/forward state");
        return CLI_OK;
    }
    if (strcmp(argv[11], "block_state")){
        cli_print(cli, "Invalid command  -Enter block_state");
        return CLI_OK;
    }

    /*  switch port_config portNo [1..17] shutdown [0..1] tpid [0x8100] aft [0..1] fallback_bd_id [0..5] block_state [0..1] */
    if (argc < 13) {
        cli_print (cli, "Incomplete command Provide block_state value (default value 0)");
        cli_print (cli, "\tFORWARDING\t0");
        cli_print (cli, "\tBLOCKED   \t1");
        cli_print (cli, "\tLEARN_ONLY\t2");
        return CLI_OK;
    }
    if (strcmp(argv[12], "?")==0){
        cli_print(cli, "Enter block_state value (default value 0)");
        cli_print (cli, "\tFORWARDING\t0");
        cli_print (cli, "\tBLOCKED   \t1");
        cli_print (cli, "\tLEARN_ONLY\t2");
        return CLI_OK;
    }
    i = atoi(argv[12]);
    if((0 > i) ||(i > 2)) {
        cli_print (cli, "Provide block_state value (default value 0)");
        cli_print (cli, "\tFORWARDING\t0");
        cli_print (cli, "\tBLOCKED   \t1");
        cli_print (cli, "\tLEARN_ONLY\t2");
        return CLI_OK;
    }
#if 0
    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted */
    if (argc < 14) {
        cli_print (cli, "Incomplete command   -Enter trusted");
        return CLI_OK;
    }
    if (strcmp(argv[13], "?")==0){
        cli_print(cli, "trusted      -Enter trusted to indicate the port is trusted");
        return CLI_OK;
    }
    if (strcmp(argv[13], "trusted")){
        cli_print(cli, "Invalid command   -Enter trusted");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5]*/
    if (argc < 15) {
        cli_print (cli, "Incomplete command  Provide trusted with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[14], "?")==0){
        cli_print(cli, "Enter trusted with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[14]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide trusted with in 0 to 5 value");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table */
    if (argc < 16) {
        cli_print (cli, "Incomplete command  -Enter tcsel_table");
        return CLI_OK;
    }
    if (strcmp(argv[15], "?")==0){
        cli_print(cli, "tcsel_table      -Enter tcsel_table for tc select table");
        return CLI_OK;
    }
    if (strcmp(argv[15], "tcsel_table")){
        cli_print(cli, "Invalid command   -Enter tcsel_table");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5]*/
    if (argc < 17) {
        cli_print (cli, "Incomplete command  Provide tcsel_table with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[16], "?")==0){
        cli_print(cli, "Enter tcsel_table with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[16]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide tcsel_table with in 0 to 5 value");
        return CLI_OK;
    }


    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5] pcp2tc_table */
    if (argc < 18) {
        cli_print (cli, "Incomplete command  -Enter pcp2tc_table");
        return CLI_OK;
    }
    if (strcmp(argv[17], "?")==0){
        cli_print(cli, "pcp2tc_table      -Enter pcp2tc_table for pcp2tc table");
        return CLI_OK;
    }
    if (strcmp(argv[17], "pcp2tc_table")){
        cli_print(cli, "Invalid command   -Enter pcp2tc_table");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5] pcp2tc_table [0..5] */
    if (argc < 19) {
        cli_print (cli, "Incomplete command Provide pcp2tc_table with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[18], "?")==0){
        cli_print(cli, "Enter pcp2tc_table with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[18]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide pcp2tc_table with in 0 to 5 value");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5] pcp2tc_table [0..5] def_cfi*/
    if (argc < 20) {
        cli_print (cli, "Incomplete command  -Enter def_cfi");
        return CLI_OK;
    }
    if (strcmp(argv[19], "?")==0){
        cli_print(cli, "def_cfi      -Enter def_cfi for default cfi value ");
        return CLI_OK;
    }
    if (strcmp(argv[19], "def_cfi")){
        cli_print(cli, "Invalid command  -Enter def_cfi");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5] pcp2tc_table [0..5] def_cfi [0..5]*/
    if (argc < 21) {
        cli_print (cli, "Incomplete command Provide def_cfi with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[20], "?")==0){
        cli_print(cli, "Enter def_cfi with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[20]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide def_cfi with in 0 to 5 value");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5] pcp2tc_table [0..5] def_cfi [0..5] def_pri */
    if (argc < 22) {
        cli_print (cli, "Incomplete command  -Enter def_pri");
        return CLI_OK;
    }
    if (strcmp(argv[21], "?")==0){
        cli_print(cli, "def_pri      -Enter def_pri for default pri value ");
        return CLI_OK;
    }
    if (strcmp(argv[21], "def_pri")){
        cli_print(cli, "Invalid command  -Enter def_pri");
        return CLI_OK;
    }

    /* switch port_config portNo [0..3] shutdown [0..1] tpid [0..1] aft [0..1] fallback_bd_id [0..5] block_state [0..1] trusted [0..5] tcsel_table [0..5] pcp2tc_table [0..5] def_cfi [0..5] def_pri [0..5]*/
    if (argc < 23) {
        cli_print (cli, "Incomplete command Provide def_pri with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[22], "?")==0){
        cli_print(cli, "Enter def_pri with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[22]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide def_pri with in 0 to 5 value");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc*/
    if (argc < 24) {
        cli_print (cli, "Incomplete command  -Enter def_tc");
        return CLI_OK;
    }
    if (strcmp(argv[23], "?")==0){
        cli_print(cli, "def_tc      -Enter def_tc for default tc value ");
        return CLI_OK;
    }
    if (strcmp(argv[23], "def_tc")){
        cli_print(cli, "Invalid command  -Enter def_tc");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]*/
    if (argc < 25) {
        cli_print (cli, "Incomplete command Provide def_tc with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[24], "?")==0){
        cli_print(cli, "Enter def_tc with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[24]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide def_tc with in 0 to 5 value");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]tc2cos_table*/
    if (argc < 26) {
        cli_print (cli, "Incomplete command  -Enter tc2cos_table");
        return CLI_OK;
    }
    if (strcmp(argv[25], "?")==0){
        cli_print(cli, "tc2cos_table      -Enter tc2cos_table for tc2cos table ");
        return CLI_OK;
    }
    if (strcmp(argv[25], "tc2cos_table")){
        cli_print(cli, "Invalid command  -Enter tc2cos_table");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]tc2cos_table[0..5]*/
    if (argc < 27) {
        cli_print (cli, "Incomplete command Provide tc2cos_table with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[26], "?")==0){
        cli_print(cli, "Enter tc2cos_table with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[26]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide tc2cos_table with in 0 to 5 value");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]tc2cos_table[0..5]pindex*/
    if (argc < 28) {
        cli_print (cli, "Incomplete command  -Enter pindex");
        return CLI_OK;
    }
    if (strcmp(argv[27], "?")==0){
        cli_print(cli, "pindex      -Enter pindex for physical index ");
        return CLI_OK;
    }
    if (strcmp(argv[27], "pindex")){
        cli_print(cli, "Invalid command  -Enter pindex");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]tc2cos_table[0..5]pindex[0..5]*/
    if (argc < 29) {
        cli_print (cli, "Incomplete command  Provide pindex with in 0 to 5 value");
        return CLI_OK;
    }
    if (strcmp(argv[28], "?")==0){
        cli_print(cli, "Enter pindex with in 0 to 5 value ");
        return CLI_OK;
    }
    i = atoi(argv[28]);
    if((0 > i) ||(i > 5)) {
        cli_print (cli, "Provide pindex with in 0 to 5 value");
        return CLI_OK;
    }
#endif
    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]tc2cos_table[0..5]pindex[0..5]csr_untag_from_btable*/
    if (argc < 14) {
        cli_print (cli, "Incomplete command Enter csr_untag_from_btable");

        return CLI_OK;
    }
    if (strcmp(argv[13], "?")==0){
        cli_print(cli, "csr_untag_from_btable      -Enter csr_untag_from_btable for untag information ");
        return CLI_OK;
    }
    if (strcmp(argv[13], "csr_untag_from_btable")){
        cli_print(cli, "Invalid command  -Enter csr_untag_from_btable");
        return CLI_OK;
    }

    /* switch port_config portNo[0..3]shutdown[0..1]tpid[0..1]aft[0..1]fallback_bd_id[0..5]block_state[0..1]trusted[0..5]tcsel_table[0..5]pcp2tc_table[0..5]def_cfi[0..5]def_pri[0..5]def_tc[0..5]tc2cos_table[0..5]pindex[0..5]csr_untag_from_btable[0.1] csr_untag_from_btable*/
    if (argc < 15) {
        cli_print (cli, "Incomplete command  Provide csr_untag_from_btable");
        cli_print (cli, "\tUntag -Based on Port Configuration        \t0");
        cli_print (cli, "\tUntag -Based on Vlan Table  Configuration \t1");
        cli_print (cli, "\t");
        return CLI_OK;
    }
    if (strcmp(argv[14], "?")==0){
        cli_print(cli, "Enter csr_untag_from_btable value");
        cli_print (cli, "\tUntag -Based on Port Configuration        \t0");
        cli_print (cli, "\tUntag -Based on Vlan Table  Configuration \t1");
        return CLI_OK;
    }
    i = atoi(argv[14]);
    if((0 > i) ||(i > 1)) {
        cli_print (cli, "Provide csr_untag_from_btable value");
        cli_print (cli, "\tUntag -Based on Port Configuration        \t0");
        cli_print (cli, "\tUntag -Based on Vlan Table  Configuration \t1");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_PORT_CONFIG;
    pmsg->pcmh_value = atoi(argv[2]); /* portNo */

    pPort = (struct port_s *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    pPort->shutdown = atoi(argv[4]); /* shutdown */
    pPort->tpid = atoi(argv[6]); /* tpid */
    pPort->aft = atoi(argv[8]); /* aft */
    pPort->fallback_bd_id = atoi(argv[10]); /* fallback_bd_id */
    pPort->block_state = atoi(argv[12]); /* block_state */
#if 0
    pPort->trusted = atoi(argv[14]); /* trusted */
    pPort->tcsel_table = atoi(argv[16]); /* tcsel_table */
    pPort->pcp2tc_table = atoi(argv[18]); /* pcp2tc_table */
    pPort->def_cfi = atoi(argv[20]); /* def_cfi */
    pPort->def_pri = atoi(argv[22]); /* def_pri */
    pPort->def_tc = atoi(argv[24]); /* def_tc */
    pPort->tc2cos_table = atoi(argv[26]); /* tc2cos_table */
    pPort->pindex = atoi(argv[28]); /* pindex */
#endif
    pPort->csr_untag_from_btable = atoi(argv[14]); /* csr_untag_from_btable */

#if 0
    cli_print(cli, "portNo = %x  shutdown = %x \ntpid = %x \naft = %x \nfallback_bd_id = %x \nblock_state = %x \ntrusted = %x \ntcsel_table = %x \npcp2tc_table = %x \ndef_cfi = %x \ndef_pri = %x \ndef_tc = %x \ntc2cos_table = %x \npindex = %x \ncsr_untag_from_btable = %x",pmsg->pcmh_value, pPort->shutdown, pPort->tpid, pPort->aft, pPort->fallback_bd_id, pPort->block_state, pPort->trusted, pPort->tcsel_table, pPort->pcp2tc_table, pPort->def_cfi, pPort->def_pri, pPort->def_tc, pPort->tc2cos_table, pPort->pindex, pPort->csr_untag_from_btable);
#endif

    cli_print(cli, "\tportNo=%d\n\tshutdown=%d\n\ttpid=0x%x\n\taft=%x\n\tfallback_bd_id=%x\n\tblock_state=%x\n\tcsr_untag_from_btable=%x",pmsg->pcmh_value, pPort->shutdown, pPort->tpid, pPort->aft, pPort->fallback_bd_id, pPort->block_state, pPort->csr_untag_from_btable);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }




    free(buffer);
    return (0);

}


int
AddSwitch_Port_Config_Cmds (struct cli_def *cli) {

    struct cli_command *port_config;

    /* switch port_config */
    port_config = cli_register_command(cli, nkCli.nk_switch, "port_config", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tPort configuration");

    /* switch port_config portNo */
    cli_register_command(cli, port_config, "portNo", Switch_Port_Config_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter portNo ");

    return 0;

}

int
AddSwitch_Private_Vlan_Add_Cmds (struct cli_def *cli) {

    struct cli_command *pvlan_config;

    /* switch private vlan config */
    pvlan_config = cli_register_command(cli, nkCli.nk_switch, "pvlan_config", NULL,
			    PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tPrivate vlan configuration");

    /* private vlan config portNo */
    cli_register_command(cli, pvlan_config, "portNo", Switch_Pvlan_Config_Callback,
			    PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter portNo ");

    return 0;
}

int
AddSwitch_Private_Vlan_Del_Cmds (struct cli_def *cli) {

    struct cli_command *pvlan_config;

    /* switch private vlan config */
    pvlan_config = cli_register_command(cli, nkCli.nk_switch, "pvlan_del", NULL,
			    PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tPrivate vlan configuration");

    /* private vlan config portNo */
    cli_register_command(cli, pvlan_config, "portNo", Switch_Pvlan_Del_Config_Callback,
			    PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter portNo ");

    return 0;
}


/* ---------------------- switch global_br_entry_config Command ------------------------------- */

int
Switch_Global_Br_Entry_Config_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t)  + sizeof(struct global_s);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    pcm_msg_header_t *pmsg;
    int i;
    struct global_s *pGlobal_br_entry;

    pmsg = (pcm_msg_header_t *)buffer;

    pmsg->pcmh_type = PCM_MSG_SWITCH_GLOBAL_BR_ENTRY_CONFIG;
    pGlobal_br_entry = (struct global_s *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    /* switch global_br_entry_config l2_splPunt_enable [0..1] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide l2_splPunt_enable  1 - Punt Enable 0 - punt Disable");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter l2 special  1 - Punt Enable  0 - punt Disable");
        return CLI_OK;
    }

    if (strncasecmp(argv[2], "0x", 2) == 0) {
        i = (int)strtol(argv[2], NULL, 16);
    } else {
        i = (int)strtol(argv[2], NULL, 10);
    }
    //i = atoi(argv[2]);
    if((0 > i) ||(i > 1)) {
        cli_print (cli, "Provide l2_splPunt_enable 1 - Punt Enable 0 - punt Disable");
        return CLI_OK;
    }
    pGlobal_br_entry->l2_special_punt_enable = i; /* l2_splPunt_enable */

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList */
    if (argc < 4) {
        cli_print (cli, "Incomplete command   -Enter fwdPortList");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "fwdPortList      -Enter fwdPortList for forward port list (in hex format)");
	return CLI_OK;
    }
    if (strcmp(argv[3], "fwdPortList")){
        cli_print(cli, "Invalid command   -Enter fwdPortList");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0x1FFFF]*/
    if (argc < 5) {
        cli_print (cli, "Incomplete command. Provide fwdPortList value");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
	    cli_portlist_help(cli,"fwdPortList");
        return CLI_OK;
    }
    if (strncasecmp(argv[4], "0x", 2) == 0) {
	    i = (int)strtol(argv[4], NULL, 16); 
    } else {
	    i = (int)strtol(argv[4], NULL, 10);
    }
    if(cli_portlist_chk(cli, i) != CLI_OK) {
	    cli_portlist_help(cli,"fwdPortList");
	    return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.forward_list = i; /* fwdPortList */


    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList */
    if (argc < 6) {
        cli_print (cli, "Incomplete command. Enter untagList");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "untagList       -Enter  untagList (in hex format)");
        return CLI_OK;
    }
    if (strcmp(argv[5], "untagList")){
        cli_print(cli, "Invalid command. -Enter untagList");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] */
    if (argc < 7) {
        cli_print (cli, "Incomplete command. -Provide untagList value");
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
	cli_portlist_help(cli,"untagList");
        return CLI_OK;
    }
    if (strncasecmp(argv[6], "0x", 2) == 0) {
	    i = (int)strtol(argv[6], NULL, 16);
    } else {
	    i = (int)strtol(argv[6], NULL, 10);
    }

    if(cli_untaglist_chk(cli, i) != CLI_OK) {
	    cli_portlist_help(cli,"untagList");
	    return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.untag_list = i; /* untagList */


    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct */
    if (argc < 8) {
        cli_print (cli, "Incomplete command  -Enter ucastHitAct");
        return CLI_OK;
    }
    if (strcmp(argv[7], "?")==0){
        cli_print(cli, "ucastHitAct      -Enter ucastHitAct for unicast hit list (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[7], "ucastHitAct")){
        cli_print(cli, "Invalid command. enter ucastHitAct");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6]*/
    if (argc < 9) {
        cli_print (cli, "Incomplete command   -Provide ucastHitAct with in 0 to 6 value");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[8], "?")==0){
        cli_print(cli, "Enter ucastHitAct with in 0 to 6 value ");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strncasecmp(argv[8], "0x", 2) == 0) {
        i = (int)strtol(argv[8], NULL, 16);
    } else {
        i = (int)strtol(argv[8], NULL, 10);
    }
    if((SWITCHAPI_MIN_UCASTHITACT > i) ||(i > SWITCHAPI_MAX_UCASTHITACT)) {
        cli_print (cli, "Provide ucastHitAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.ucast_hit_action = i; /* ucastHitAct */

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct */
    if (argc < 10) {
        cli_print (cli, "Incomplete command   -Enter mcastHitAct");
        return CLI_OK;
    }
    if (strcmp(argv[9], "?")==0){
        cli_print(cli, "mcastHitAct        -Enter mcastHitAct for multicast hit list (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[9], "mcastHitAct")){
        cli_print(cli, "Invalid command     -Enter mcastHitAct");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6]*/
    if (argc < 11) {
        cli_print (cli, "Incomplete command  -Provide mcastHitAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[10], "?")==0){
        cli_print(cli, "Enter mcastHitAct with in 0 to 6 value ");
	    cli_action_field_help(cli);
        return CLI_OK;
    }

    if (strncasecmp(argv[10], "0x", 2) == 0) {
        i = (int)strtol(argv[10], NULL, 16);
    } else {
        i = (int)strtol(argv[10], NULL, 10);
    }

    if((SWITCHAPI_MIN_MCASTHITACT > i) ||(i > SWITCHAPI_MAX_MCASTHITACT)) {
        cli_print (cli, "Provide mcastHitAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.mcast_hit_action = i; /* mcastHitAct */

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct */
    if (argc < 12) {
        cli_print (cli, "Incomplete command   -Enter ucastMissAct");
        return CLI_OK;
    }
    if (strcmp(argv[11], "?")==0){
        cli_print(cli, "ucastMissAct      -Enter ucastMissAct for unicast miss list (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[11], "ucastMissAct")){
        cli_print(cli, "Invalid command    -Enter ucastMissAct");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6]*/
    if (argc < 13) {
        cli_print (cli, "Incomplete command  -Provide ucastMissAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[12], "?")==0){
        cli_print(cli, "Enter ucastMissAct with in 0 to 6 value ");
	    cli_action_field_help(cli);
        return CLI_OK;
    }

    if (strncasecmp(argv[12], "0x", 2) == 0) {
        i = (int)strtol(argv[12], NULL, 16);
    } else {
        i = (int)strtol(argv[12], NULL, 10);
    }

    if((SWITCHAPI_MIN_UCASTMISSACT > i) ||(i > SWITCHAPI_MAX_UCASTMISSACT)) {
        cli_print (cli, "Provide ucastMissAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.ucast_miss_action = i; /* ucastMissAct */

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct*/
    if (argc < 14) {
        cli_print (cli, "Incomplete command     -Enter mcastMissAct");
        return CLI_OK;
    }
    if (strcmp(argv[13], "?")==0){
        cli_print(cli, "mcastMissAct      -Enter mcastMissAct for multicast miss list (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[13], "mcastMissAct")){
        cli_print(cli, "Invalid command     -Enter mcastMissAct");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct [0..6]*/
    if (argc < 15) {
        cli_print (cli, "Incomplete command     -Provide mcastMissAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[14], "?")==0){
        cli_print(cli, "Enter mcastMissAct with in 0 to 6 value ");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    
    if (strncasecmp(argv[14], "0x", 2) == 0) {
        i = (int)strtol(argv[14], NULL, 16);
    } else {
        i = (int)strtol(argv[14], NULL, 10);
    }

    if((SWITCHAPI_MIN_MCASTMISSACT > i) ||(i > SWITCHAPI_MAX_MCASTMISSACT)) {
        cli_print (cli, "Provide mcastMissAct with in 0 to 6 value");
	    cli_action_field_help(cli);
        return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.mcast_miss_action = i; /* mcastMissAct */

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct [0..6] mstpAct */
    if (argc < 16) {
        cli_print (cli, "Incomplete command  -Enter mstpAct");
        return CLI_OK;
    }
    if (strcmp(argv[15], "?")==0){
        cli_print(cli, "mstpAct      -Enter mstpAct for mspt action list (in dec format)");
        return CLI_OK;
    }
    if (strcmp(argv[15], "mstpAct")){
        cli_print(cli, "Invalid command   -Enter mstpAct");
        return CLI_OK;
    }

    /* switch global_br_entry_config l2_splPunt_enable [0..1] fwdPortList [0..0xF] untagList [0..0xF] ucastHitAct [0..6] mcastHitAct [0..6] ucastMissAct [0..6] mcastMissAct [0..6] mstpAct [0..6]*/
    if (argc < 17) {
        cli_print (cli, "Incomplete command     -Provide mstpAct with in 0 to 6 value");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[16], "?")==0){
        cli_print(cli, "Enter mstpAct with in 0 to 6 value ");
	cli_action_field_help(cli);
        return CLI_OK;
    }

    if (strncasecmp(argv[16], "0x", 2) == 0) {
        i = (int)strtol(argv[16], NULL, 16);
    } else {
        i = (int)strtol(argv[16], NULL, 10);
    }

    if((SWITCHAPI_MIN_MSTPACT > i) ||(i > SWITCHAPI_MAX_MSTPACT)) {
        cli_print (cli, "Provide mstpAct with in 0 to 6 value");
	cli_action_field_help(cli);
        return CLI_OK;
    }
    pGlobal_br_entry->fallback_bd_entry.mstp_action = i; /* mstpAct */

//    pmsg->pcmh_type = PCM_MSG_SWITCH_GLOBAL_BR_ENTRY_CONFIG;
//    cli_print(cli, "argv[0] = %s", argv[0]);

//    pGlobal_br_entry = (struct global_s *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    //pGlobal_br_entry->l2_special_punt_enable = atoi(argv[2]); /* l2_splPunt_enable */
    //pGlobal_br_entry->fallback_bd_entry.forward_list = atoi(argv[4]); /* fwdPortList */
    //pGlobal_br_entry->fallback_bd_entry.untag_list = atoi(argv[6]); /* untagList */
    //pGlobal_br_entry->fallback_bd_entry.ucast_hit_action = atoi(argv[8]); /* ucastHitAct */
    //pGlobal_br_entry->fallback_bd_entry.mcast_hit_action = atoi(argv[10]); /* mcastHitAct */
    //pGlobal_br_entry->fallback_bd_entry.ucast_miss_action = atoi(argv[12]); /* ucastMissAct */
    //pGlobal_br_entry->fallback_bd_entry.mcast_miss_action = atoi(argv[14]); /* mcastMissAct */
    //pGlobal_br_entry->fallback_bd_entry.mstp_id = atoi(argv[16]); /* mstpAct */


    cli_print(cli, "%s:\n\tl2_splPunt_enable = %X,\n\tfwdPortList = 0x%X,\n\tuntagList = 0x%X,\n\tucastHitAct = %s,\n\tmcastHitAct = %s,\n\tucastMissAct = %s,\n\tmcastMissAct = %s,\n\tmstpAct = %s", 
                    argv[0],
                    pGlobal_br_entry->l2_special_punt_enable,
                    pGlobal_br_entry->fallback_bd_entry.forward_list,
                    pGlobal_br_entry->fallback_bd_entry.untag_list,
                    get_action_name(pGlobal_br_entry->fallback_bd_entry.ucast_hit_action),
                    get_action_name(pGlobal_br_entry->fallback_bd_entry.mcast_hit_action),
                    get_action_name(pGlobal_br_entry->fallback_bd_entry.ucast_miss_action),
                    get_action_name(pGlobal_br_entry->fallback_bd_entry.mcast_miss_action),
                    get_action_name(pGlobal_br_entry->fallback_bd_entry.mstp_action) );

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    free(buffer);
    return (0);

}


int
AddSwitch_Global_Br_Entry_Config_Cmds (struct cli_def *cli) {

    struct cli_command *br_global_entry_config;

    /* switch global_br_entry_config */
    br_global_entry_config = cli_register_command(cli, nkCli.nk_switch, "global_br_entry_config", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tGlobal bridge entry configuration");


    /* switch global_br_entry_config l2_splPunt_enable */
    cli_register_command(cli, br_global_entry_config, "l2_splPunt_enable", Switch_Global_Br_Entry_Config_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter l2_splPunt_enable ");
    return 0;

}

/* ---------------------- switch br_entry_del Command ------------------------------- */
int
Switch_Br_Entry_Del_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_del vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command   -Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value ");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_DEL;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */
    cli_print(cli, "vlanId = %x", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    free(buffer);
    return (0);

}


int
AddSwitch_Br_Entry_Del_Cmds (struct cli_def *cli) {

    struct cli_command *br_entry_del;

    /* switch br_entry_del */
    br_entry_del = cli_register_command(cli, nkCli.nk_switch, "br_entry_del", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tDelete bridge entry");

    /* switch br_entry_del vlanId */
    cli_register_command(cli, br_entry_del, "vlanId", Switch_Br_Entry_Del_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return (0);
}



/* ---------------------- switch br_entry_del_ports Command ------------------------------- */
int
Switch_Br_Entry_Del_Ports_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch br_entry_del_ports vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command   -Provide vlanId with in 1 to 4093 value");
        goto label_br_entry_del_ports_exit;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value (in dec format)");
        goto label_br_entry_del_ports_exit;
    }

    if (strncasecmp(argv[2], "0x", 2) == 0) {
        i = (int)strtol(argv[2], NULL, 16);
    } else {
        i = (int)strtol(argv[2], NULL, 10);
    }

    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        goto label_br_entry_del_ports_exit;
    }

    pmsg->pcmh_value = i; /* vlanId */

    /* switch br_entry_del_ports vlanId [1..4093] portno */
    if (argc < 4) {
        cli_print (cli, "Incomplete command    -Enter portNo");
        goto label_br_entry_del_ports_exit;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "portNo      -Enter portNo");
        goto label_br_entry_del_ports_exit;
    }
    if (strcmp(argv[3], "portNo")){
        cli_print(cli, "Invalid command  -Enter portNo");
        goto label_br_entry_del_ports_exit;
    }


    /* switch br_entry_del_ports vlanId [1..4093] portno [1..4] */
    if (argc < 5) {
        cli_print (cli, "Incomplete command   -Provide portNo with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
	    portlist_display_add_delete(cli,"portNo","delete");
        goto label_br_entry_del_ports_exit;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter portNo with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
	    portlist_display_add_delete(cli,"portNo","delete");
        goto label_br_entry_del_ports_exit;
    }

    if (strncasecmp(argv[4], "0x", 2) == 0) {
        i = (int)strtol(argv[4], NULL, 16);
    } else {
        i = (int)strtol(argv[4], NULL, 10);
    }

    if(((SWITCHAPI_MIN_PORT_NO) > i) ||(i > (SWITCHAPI_MAX_PORT_NO))) {
        cli_print (cli, "Provide portNo with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
	    portlist_display_add_delete(cli,"portNo","delete");
        goto label_br_entry_del_ports_exit;
    }
    pmsg->pcmh_flags = i; /*Forward list*/

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_DEL_PORTS;

  

    /*Forward list*/
    /*
    if(atoi(argv[4]) == 1){
    	pmsg->pcmh_flags = 1;
    }else if(atoi(argv[4]) == 2){
	pmsg->pcmh_flags = 2;
    }else if(atoi(argv[4]) == 3){
        pmsg->pcmh_flags = 4;
    }else if(atoi(argv[4]) == 4){
        pmsg->pcmh_flags = 8;
    }else{
	   cli_print (cli, "Provide portNo with in %d to %d value", SWITCHAPI_MIN_PORT_NO, SWITCHAPI_MAX_PORT_NO);
	   return CLI_OK;
    }
    */

    cli_print(cli, "vlanId = %d", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
    }

label_br_entry_del_ports_exit:
    free(buffer);
    return (CLI_OK);

}


int
AddSwitch_Br_Entry_Del_Ports_Cmds (struct cli_def *cli) {

    struct cli_command *br_entry_del_ports;

    /* switch br_entry_del_ports */
    br_entry_del_ports = cli_register_command(cli, nkCli.nk_switch, "br_entry_del_ports", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tDelete bridge entry ports");

    /* switch br_entry_del_ports vlanId */
    cli_register_command(cli, br_entry_del_ports, "vlanId", Switch_Br_Entry_Del_Ports_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return (0);
}


/* ---------------------- switch fp_mac_entry_add Command ------------------------------- */
int
Switch_Fp_Mac_Entry_Add_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    INT tsize = sizeof(pcm_msg_header_t)  + sizeof(switch_fp_mac_entry_params_t);
    switch_fp_mac_entry_params_t *pmac;
    UCHAR *buffer = (unsigned char *)malloc(tsize);
    INT i, res,*action_entry = NULL, queueNo = 0;
    UCHAR addr[6];
    CHAR dummy;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    pmac = (switch_fp_mac_entry_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));

    /* switch mac_entry_add vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command  -Provide vlanId with in 1 to 4093 value");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value (in dec format)");
        goto lable_mac_entry_add_exit;
    }

    if (strncasecmp(argv[2], "0x", 2) == 0) {
	    i = (int)strtol(argv[2], NULL, 16);
    } else {
	    i = (int)strtol(argv[2], NULL, 10);
    }

    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        goto lable_mac_entry_add_exit;
    }

    pmsg->pcmh_type = PCM_MSG_SWITCH_BR_ENTRY_SEARCH;
    pmsg->pcmh_value = i; /* vlanId */

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        goto lable_mac_entry_add_exit;
    }

    action_entry = (int *)buffer;

    if (*action_entry == -1) {
        cli_print (cli, "Provide vlan Id which is part of vlan/bridge table");
        goto lable_mac_entry_add_exit;
    }

    pmac->swbea_vlanId = i;

    /* switch mac_entry_add vlanId [1..4093] portNo [0..1] mac */
    if (argc < 4) {
        cli_print (cli, "Incomplete command  -Enter mac\n");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "mac      -Enter MAC Address\n");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[3], "mac")){
        cli_print(cli, "Invalid command -Enter mac\n");
        goto lable_mac_entry_add_exit;
    }


    /* switch mac_entry_add vlanId [1..4093] portNo [0..1] mac xx:xx:xx:xx:xx:xx */
    if (argc < 5) {
        cli_print (cli, "Incomplete command  -Provide MAC Address in xx:xx:xx:xx:xx:xx format\n");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter MAC Address in xx:xx:xx:xx:xx:xx format \n");
        goto lable_mac_entry_add_exit;
    }

    res = sscanf(argv[4], "%2hhx:%2hhx:%2hhx:%2hhx:%2hhx:%2hhx%c",
                   &addr[0], &addr[1], &addr[2], &addr[3], &addr[4], &addr[5],
                   &dummy);

    if (res == EOF) {
        fprintf(stderr, "Reached end of input without matching\n");
        goto lable_mac_entry_add_exit;
    } else if (res < 6) {
        fprintf(stderr, "Got fewer hex digits than expected\n");
        goto lable_mac_entry_add_exit;
    } else if (res > 6) {
        fprintf(stderr, "Got extra characters after input\n");
        goto lable_mac_entry_add_exit;
    }

    pmac->addr[0] = addr[0];
    pmac->addr[1] = addr[1];
    pmac->addr[2] = addr[2];
    pmac->addr[3] = addr[3]; //need to add function to convert
    pmac->addr[4] = addr[4];
    pmac->addr[5] = addr[5];

    /* switch mac_entry_add vlanId [1..4093] portNo */
    if (argc < 6) {
        cli_print (cli, "Incomplete command    -Enter portList");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "portList      -Enter portList");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[5], "portList")){
        cli_print(cli, "Invalid command   -Enter portList");
        goto lable_mac_entry_add_exit;
    }
    /* switch mac_entry_add vlanId [1..4093] portNo [0..1] */
    if (argc < 7) {
        cli_print (cli, "Incomplete command  -Provide portList val");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[6], "?")==0){
	    cli_portlist_help(cli,"portList");
        goto lable_mac_entry_add_exit;
    }

    if (strncasecmp(argv[6], "0x", 2) == 0) {
	    i = (int)strtol(argv[6], NULL, 16);
    } else {
	    i = (int)strtol(argv[6], NULL, 10);
    }

    if (cli_portlist_chk(cli, i) != CLI_OK) {
	    cli_portlist_help(cli,"portList");
        goto lable_mac_entry_add_exit;
    }

    pmac->swbea_fwdPortList = i;


    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct */
    if (argc < 8) {
        cli_print (cli, "Incomplete command. enter HitAct");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[7], "?")==0){
        cli_print(cli, "HitAct      -Enter Hit Action for this mac");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[7], "HitAct")){
        cli_print(cli, "Invalid command. enter HitAct");
        goto lable_mac_entry_add_exit;
    }

    /* switch br_entry_add vlanId [1..4093] fwdPortList [0..15] untagList [0..15] ucastHitAct [0..6]*/
    if (argc < 9) {
        cli_print (cli, "Incomplete command. Provide HitAct with in 0 to 6 value\n");
	    cli_action_field_help(cli);
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[8], "?")==0){
        cli_print(cli, "Enter HitAct with in 0 to 6 value\n");
	    cli_action_field_help(cli);
        goto lable_mac_entry_add_exit;
    }

    if (strncasecmp(argv[8], "0x", 2) == 0) {
	    i = (int)strtol(argv[8], NULL, 16);
    } else {
	    i = (int)strtol(argv[8], NULL, 10);
    }

    if((SWITCHAPI_MIN_UCASTHITACT > i) ||(i > SWITCHAPI_MAX_UCASTHITACT)) {
        cli_print (cli, "Provide HitAct with in 0 to 6 value\n");
	    cli_action_field_help(cli);
        goto lable_mac_entry_add_exit;
    }

    pmac->swbea_hitAct = i;

    if (argc < 10) {
        cli_print (cli, "Incomplete command  -Provide tc\n");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[9], "?")==0){
        cli_print(cli, "Enter tc\n");
        goto lable_mac_entry_add_exit;
    }

    if (strcmp(argv[9], "tc")){
        cli_print(cli, "Invalid command. enter tc");
        goto lable_mac_entry_add_exit;
    }

    if (argc < 11) {
        cli_print (cli, "Incomplete command  -Provide tc val\n");
        goto lable_mac_entry_add_exit;
    }
    if (strcmp(argv[10], "?")==0){
        cli_print(cli, "Enter value from 0 to 7\n");
        goto lable_mac_entry_add_exit;
    }

    if (strncasecmp(argv[10], "0x", 2) == 0) {
	    queueNo = (int)strtol(argv[10], NULL, 16);
    } else {
	    queueNo = (int)strtol(argv[10], NULL, 10);
    }

    if (0 > queueNo || 7 < queueNo) {
        cli_print (cli, "Provide tc within 0 to 7 value\n");
        goto lable_mac_entry_add_exit;
    }

    pmac->swbea_tc = queueNo;

    cli_print(cli, "MAC ADDRESS: %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx",
         pmac->addr[0], pmac->addr[1], pmac->addr[2], pmac->addr[3], pmac->addr[4], pmac->addr[5]);


    pmsg->pcmh_type = PCM_MSG_SWITCH_MAC_ENTRY_ADD;

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        goto lable_mac_entry_add_exit;
    }

    action_entry = (int*)buffer;

    if(*action_entry == -1){
        cli_print(cli, "\tMAC Entry Not Added");
    }
    else{
        cli_print(cli, "\tMAC Entry Added Successfully");
    }

lable_mac_entry_add_exit:
    free(buffer);
    return CLI_OK;
}

int
AddSwitch_Mac_Entry_Add_Cmds (struct cli_def *cli) {

    struct cli_command *mac_entry_add;

    /* switch mac_entry_add */
    mac_entry_add = cli_register_command(cli, nkCli.nk_switch, "mac_entry_add", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tAdd mac entry to the table");

    /* switch mac_entry_add vlanId */
    cli_register_command(cli, mac_entry_add, "vlanId", Switch_Fp_Mac_Entry_Add_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return (0);
}



/* ---------------------- switch fp_mac_entry_del Command ------------------------------- */
int
Switch_Fp_Mac_Entry_Del_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t)  + sizeof(switch_fp_mac_entry_params_t);
    switch_fp_mac_entry_params_t *pmac;
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i, res;
    unsigned char addr[6];
    char dummy;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch mac_entry_del vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command. Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value ");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_MAC_ENTRY_DEL;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */

    /* switch mac_entry_del vlanId [1..4093]  mac */
    if (argc < 4) {
        cli_print (cli, "Incomplete command  Enter MAC Address\n");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "mac      -Enter MAC Address\n");
        return CLI_OK;
    }
    if (strcmp(argv[3], "mac")){
        cli_print(cli, "Invalid command  -Enter MAC Address\n");
        return CLI_OK;
    }


    /* switch mac_entry_del vlanId [1..4093]  mac xx:xx:xx:xx:xx:xx */
    if (argc < 5) {
        cli_print (cli, "Incomplete command -Provide MAC Address in xx:xx:xx:xx:xx:xx format\n");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter MAC Address in xx:xx:xx:xx:xx:xx format \n");
        return CLI_OK;
    }

    pmac = (switch_fp_mac_entry_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));
    res = sscanf(argv[4], "%2hhx:%2hhx:%2hhx:%2hhx:%2hhx:%2hhx%c",
                   &addr[0], &addr[1], &addr[2], &addr[3], &addr[4], &addr[5],
                   &dummy);

    if (res == EOF) {
      fprintf(stderr, "Reached end of input without matching\n");
      return CLI_OK;
    } else if (res < 6) {
      fprintf(stderr, "Got fewer hex digits than expected\n");
      return CLI_OK;
    } else if (res > 6) {
      fprintf(stderr, "Got extra characters after input\n");
      return CLI_OK;
    }
    pmac->addr[0] = addr[0];
    pmac->addr[1] = addr[1];
    pmac->addr[2] = addr[2];
    pmac->addr[3] = addr[3]; //need to add function to convert
    pmac->addr[4] = addr[4];
    pmac->addr[5] = addr[5];

    cli_print(cli, "MAC ADDRESS: %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx",
         pmac->addr[0], pmac->addr[1], pmac->addr[2], pmac->addr[3], pmac->addr[4], pmac->addr[5]);


    cli_print(cli, "vlanId = %x", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    free(buffer);
    return (0);

}

int
AddSwitch_Mac_Entry_Del_Cmds (struct cli_def *cli) {

    struct cli_command *mac_entry_del;

    /* switch mac_entry_del */
    mac_entry_del = cli_register_command(cli, nkCli.nk_switch, "mac_entry_del", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tDelete mac entry to the table");

    /* switch mac_entry_del vlanId */
    cli_register_command(cli, mac_entry_del, "vlanId", Switch_Fp_Mac_Entry_Del_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return (0);
}




/* ---------------------- switch fp_mac_entry_search Command ------------------------------- */
int
Switch_Fp_Mac_Entry_Search_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t)  + sizeof(switch_fp_mac_entry_params_t);
    switch_fp_mac_entry_params_t *pmac;
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i, res, *action_entry,fwd_action = 0;
    unsigned char addr[6];
    char dummy;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch mac_entry_search vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command -Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value ");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_MAC_ENTRY_SEARCH;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */

    /* switch mac_entry_search vlanId [1..4093] mac */
    if (argc < 4) {
        cli_print (cli, "Incomplete command  -Enter MAC Address\n");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "mac      -Enter MAC Address\n");
        return CLI_OK;
    }
    if (strcmp(argv[3], "mac")){
        cli_print(cli, "Invalid command  -Enter MAC Address\n");
        return CLI_OK;
    }


    /* switch mac_entry_search vlanId [1..4093]  mac xx:xx:xx:xx:xx:xx */
    if (argc < 5) {
        cli_print (cli, "Incomplete command  -Provide MAC Address in xx:xx:xx:xx:xx:xx format\n");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter MAC Address in xx:xx:xx:xx:xx:xx format \n");
        return CLI_OK;
    }

    pmac = (switch_fp_mac_entry_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));
    res = sscanf(argv[4], "%2hhx:%2hhx:%2hhx:%2hhx:%2hhx:%2hhx%c",
                   &addr[0], &addr[1], &addr[2], &addr[3], &addr[4], &addr[5],
                   &dummy);

    if (res == EOF) {
      fprintf(stderr, "Reached end of input without matching\n");
      return CLI_OK;
    } else if (res < 6) {
      fprintf(stderr, "Got fewer hex digits than expected\n");
      return CLI_OK;
    } else if (res > 6) {
      fprintf(stderr, "Got extra characters after input\n");
      return CLI_OK;
    }

    pmac->addr[0] = addr[0];
    pmac->addr[1] = addr[1];
    pmac->addr[2] = addr[2];
    pmac->addr[3] = addr[3]; //need to add function to convert
    pmac->addr[4] = addr[4];
    pmac->addr[5] = addr[5];

    cli_print(cli, "MAC ADDRESS: %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx",
         pmac->addr[0], pmac->addr[1], pmac->addr[2], pmac->addr[3], pmac->addr[4], pmac->addr[5]);


    cli_print(cli, "  vlanId = %x", pmsg->pcmh_value);
    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }
    action_entry = (int *)buffer;
    if(*action_entry == -1){
    	cli_print(cli, "\tEntry NOT FOUND");
	goto END;
    } else
    	cli_print(cli, "\tEntry FOUND");

    cli_print(cli, "\tAction Entry :%x", *action_entry);

    if((*action_entry & MAC_2F_ENTRY_FRESH_MASK))
    	cli_print(cli, "\tFresh Bit Set");

    if((*action_entry & MAC_2F_ENTRY_STATIC_MASK)) {
    	cli_print(cli, "\tStatic Entry : TC 0x%x", (*action_entry & MAC_2F_ENTRY_TC_MASK) >> MAC_2F_ENTRY_TC_START_POS);
    } else {
    	cli_print(cli, "\tDynamic Entry");
    }

    /* Display Port number */
    cli_print_portlist(cli, "FORWARD PORTS", (*action_entry & FWD_PORT_LIST_MASK));

    /* Display Forward action */
    fwd_action = (*action_entry >> 11) & 0x7;

    cli_action_print(cli, "FWD Action", fwd_action);
END:
    free(buffer);
    return (0);

}

int
AddSwitch_Mac_Entry_Search_Cmds (struct cli_def *cli) {

    struct cli_command *mac_entry_search;

    /* switch mac_entry_search */
    mac_entry_search = cli_register_command(cli, nkCli.nk_switch, "mac_entry_search", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tSearch mac entry in the table");

    /* switch mac_entry_search vlanId */
    cli_register_command(cli, mac_entry_search, "vlanId", Switch_Fp_Mac_Entry_Search_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tEnter vlanId ");

    return (0);

}




/* ---------------------- switch fp_mac_entry_update Command ------------------------------- */
int
Switch_Fp_Mac_Entry_Update_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t)  + sizeof(switch_fp_mac_entry_params_t);
    switch_fp_mac_entry_params_t *pmac;
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i, res,mac_entry=0,*action_entry = NULL;
    unsigned char addr[6];
    char dummy;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* switch mac_entry_update vlanId [1..4093] */
    if (argc < 3) {
        cli_print (cli, "Incomplete command  -Provide vlanId with in 1 to 4093 value");
        return CLI_OK;
    }
    if (strcmp(argv[2], "?")==0){
        cli_print(cli, "Enter vlan Id with in 1 to 4093 value ");
        return CLI_OK;
    }
    i = atoi(argv[2]);
    if((SWITCHAPI_MIN_VLAN_ID > i) ||(i > SWITCHAPI_MAX_VLAN_ID)) {
        cli_print (cli, "Provide vlan Id with in 1 to 4093 value");
        return CLI_OK;
    }


    /* switch mac_entry_update vlanId [1..4093] portNo */
    if (argc < 4) {
        cli_print (cli, "Incomplete command  -Enter portNo");
        return CLI_OK;
    }
    if (strcmp(argv[3], "?")==0){
        cli_print(cli, "portNo      -Enter portNo");
        return CLI_OK;
    }
    if (strcmp(argv[3], "portNo")){
        cli_print(cli, "Invalid command  -Enter portNo");
        return CLI_OK;
    }
    /* switch mac_entry_update vlanId [1..4093] portNo [0..1] */
    if (argc < 5) {
        cli_print (cli, "Incomplete command  -Provide portNo 0-EMAC1 or 1-EMAC2");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter portNo 0-EMAC1 or 1-EMAC2");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if((0 > i) ||(i > 1)) {
        cli_print (cli, "Provide portNo 0-EMAC1 or 1-EMAC2");
        return CLI_OK;
    }
    /*Updated port number to mac aentry */
    mac_entry |= (1 << i) ;


    /* switch mac_entry_update vlanId [1..4093] portNo[0.1] fwd_action */
    if (argc < 6) {
        cli_print (cli, "Incomplete command  -Enter Forward Action");
        return CLI_OK;
    }
    if (strcmp(argv[5], "?")==0){
        cli_print(cli, "fwd_action      -Enter Forward Action");
        return CLI_OK;
    }
    if (strcmp(argv[5], "fwd_action")){
        cli_print(cli, "Invalid command  -Enter Forward Action");
        return CLI_OK;
    }
    /* switch mac_entry_update vlanId [1..4093] portNo [0..1] fwd_action[0..6]*/
    if (argc < 7) {
        cli_print (cli, "Incomplete command  -Provide Forward Action value with in 0 to 6");
        cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[6], "?")==0){
        cli_print(cli, "Enter Forward Action value with in 0 to 6 ");
        cli_action_field_help(cli);
        return CLI_OK;
    }
    i = atoi(argv[6]);
    if((SWITCHAPI_MIN_ACTION_FIELD_TYPE > i) ||(i > SWITCHAPI_MAX_ACTION_FIELD_TYPE)) {
        cli_print (cli, "Provide Forward Action value with in 0 to 6");
        cli_action_field_help(cli);
        return CLI_OK;
    }
    /*Updated fwd_action to mac aentry */
    mac_entry |= (i << 11);

   /* switch mac_entry_update vlanId [1..4093] portNo[0.1] fwd_action [0..6] static */
    if (argc < 8) {
        cli_print (cli, "Incomplete command  -Enter Static 0-Disable or 1-Enable");
        return CLI_OK;
    }
    if (strcmp(argv[7], "?")==0){
        cli_print(cli, "static      -Enter Static 0-Disable or 1-Enable");
        return CLI_OK;
    }
    if (strcmp(argv[7], "static")){
        cli_print(cli, "Invalid command  -Enter Static 0-Disable or 1-Enable");
        return CLI_OK;
    }
    /* switch mac_entry_update vlanId [1..4093] portNo [0..1] fwd_action[0..6] static [0.1]*/
    if (argc < 9) {
        cli_print (cli, "Incomplete command  -Provide Static 0-Disable or 1-Enable");
        cli_action_field_help(cli);
        return CLI_OK;
    }
    if (strcmp(argv[8], "?")==0){
        cli_print(cli, "Enter Static 0-Disable or 1-Enable ");
        cli_action_field_help(cli);
        return CLI_OK;
    }
    i = atoi(argv[8]);
    if((SWITCHAPI_MIN_STATIC_VALUE > i) ||(i > SWITCHAPI_MAX_STATIC_VALUE)) {
        cli_print (cli, "Provide Static 0-Disable or 1-Enable");
        cli_action_field_help(cli);
        return CLI_OK;
    }
    /*Updated static bit to mac aentry */
    mac_entry |= (i << 30);


    /* switch mac_entry_update vlanId [1..4093] portNo [0..1] fwd_action[0..6] static [0.1] mac */
    if (argc < 10) {
        cli_print (cli, "Incomplete command  -Enter MAC Address\n");
        return CLI_OK;
    }
    if (strcmp(argv[9], "?")==0){
        cli_print(cli, "mac      -Enter MAC Address\n");
        return CLI_OK;
    }
    if (strcmp(argv[9], "mac")){
        cli_print(cli, "Invalid command  -Enter MAC Address\n");
        return CLI_OK;
    }


    /* switch mac_entry_add vlanId [1..4093] portNo [0..1] fwd_action[0..6] static [0.1] mac xx:xx:xx:xx:xx:xx */
    if (argc < 11) {
        cli_print (cli, "Incomplete command  Provide MAC Address in xx:xx:xx:xx:xx:xx format\n");
        return CLI_OK;
    }
    if (strcmp(argv[10], "?")==0){
        cli_print(cli, "Enter MAC Address in xx:xx:xx:xx:xx:xx format \n");
        return CLI_OK;
    }

    pmac = (switch_fp_mac_entry_params_t *)((unsigned char *)buffer + sizeof(pcm_msg_header_t));
    res = sscanf(argv[10], "%2hhx:%2hhx:%2hhx:%2hhx:%2hhx:%2hhx%c",
                   &addr[0], &addr[1], &addr[2], &addr[3], &addr[4], &addr[5],
                   &dummy);

    pmsg->pcmh_type = PCM_MSG_SWITCH_MAC_ENTRY_UPDATE;
    pmsg->pcmh_value = atoi(argv[2]); /* vlanId */
    pmsg->pcmh_flags = mac_entry; /* mac_entry */

    if (res == EOF) {
      fprintf(stderr, "Reached end of input without matching\n");
      return CLI_OK;
    } else if (res < 6) {
      fprintf(stderr, "Got fewer hex digits than expected\n");
      return CLI_OK;
    } else if (res > 6) {
      fprintf(stderr, "Got extra characters after input\n");
      return CLI_OK;
    }

    pmac->addr[0] = addr[0];
    pmac->addr[1] = addr[1];
    pmac->addr[2] = addr[2];
    pmac->addr[3] = addr[3]; //need to add function to convert
    pmac->addr[4] = addr[4];
    pmac->addr[5] = addr[5];

    cli_print(cli, "MAC ADDRESS: %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx",
         pmac->addr[0], pmac->addr[1], pmac->addr[2], pmac->addr[3], pmac->addr[4], pmac->addr[5]);


    cli_print(cli, "vlanId = %x portNo %x fwd_action %x static %x", pmsg->pcmh_value,atoi(argv[4]),atoi(argv[6]),atoi(argv[8]));
    cli_print(cli, "mac_entry = %x",pmsg->pcmh_flags);

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }
    action_entry = (int *)buffer;
    if(*action_entry == -1)
       cli_print(cli, "\tMAC ENTRY NOT FOUND TO UPDATE");
    else
       cli_print(cli, "\tUpdated MAC Entry Successfully");

    free(buffer);
    return (0);

}

int
AddSwitch_Mac_Entry_Update_Cmds (struct cli_def *cli) {

    struct cli_command *mac_entry_update;

    /* switch mac_entry_update */
    mac_entry_update = cli_register_command(cli, nkCli.nk_switch, "mac_entry_update", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\t\tUpdate mac entry to the table");

    /* switch mac_entry_update vlanId */
    cli_register_command(cli, mac_entry_update, "vlanId", Switch_Fp_Mac_Entry_Update_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter vlanId ");

    return (0);
}


int
Get_Ltc_Timediff_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;
    pmsg->pcmh_type = PCM_MSG_SWITCH_LTC_GET_TIMEDIFF;

    pmsg->pcmh_value = atoi(argv[2]); /* dev_no */
    pmsg->pcmh_flags = atoi(argv[4]); /* channel_no */

    cli_print(cli, "dev_no %d  channel_no %d \n ", pmsg->pcmh_value, pmsg->pcmh_flags);

    if(fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }

    UINT *timediff;
    timediff = (UINT *)buffer;
    cli_print(cli, " DEVICE NO\tCHANNEL NO\t\t TIME DIFFERENCE (Sec)  \n");
    cli_print(cli, " %d\t\t%d\t\t%d\n ", atoi(argv[2]), atoi(argv[4]), *timediff);

    free(buffer);
    return (0);


}




int
AddSwitch_ltc_get_timediff_Cmds (struct cli_def *cli) {

    struct cli_command *ltc_get_timediff, *Dev_No, *Dev_No_Arg, *Channel_No;
    char buf[16], helpText[1024];
    int    dev_idx, channel_idx;

    /* show  ltc_timediff*/
    ltc_get_timediff = cli_register_command(cli, nkCli.nk_show, "ltc_timediff", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tShow ltc time difference");

    /* show  ltc_timediff dev_no */
    Dev_No = cli_register_command(cli, ltc_get_timediff, "dev_no", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter dev_no ");

    for(dev_idx=1; dev_idx <=4; ++dev_idx){

        snprintf(buf, sizeof(buf), "%d", dev_idx);
        snprintf(helpText, sizeof(helpText), "set dev_no %d ", dev_idx);
        /* show  ltc_timediff dev_no [1..4] */
        Dev_No_Arg = cli_register_command(cli, Dev_No, buf , NULL,
                                    PRIVILEGE_UNPRIVILEGED, MODE_EXEC, helpText);

        /* show  ltc_timediff dev_no [1..4] channel_no */
        Channel_No = cli_register_command(cli, Dev_No_Arg, "channel_no", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "enter channel_no");

        for(channel_idx = 1; channel_idx <=4; ++channel_idx){

            snprintf(buf, sizeof(buf), "%d", channel_idx);
            snprintf(helpText, sizeof(helpText), "Enter channel_no %d .", channel_idx);
            /* show  ltc_timediff dev_no [1..4] channel_no [1..4] */
            cli_register_command(cli, Channel_No, buf, Get_Ltc_Timediff_Callback,
                                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, helpText);
        }
    }

    return (0);
}

/* ---------------------- switch ltc_set_HIFseconds Command ------------------------------- */
int
Set_Ltc_HIFseconds_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* show  ltc_set_HIF1seconds dev_no [1..4] seconds [1 to 0xFFFFFFFF] */
    if (argc < 5) {
        cli_print (cli, "Incomplete command. Provide seconds with in 1 to 0xFFFFFFFF value");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter seconds with in 1 to 0xFFFFFFFF value ");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if ((1 > i) ||(i > 0xFFFFFFFF)) {
        cli_print (cli, "Provide seconds with in 1 to 0xFFFFFFFF value");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_LTC_HIF_SECONDS;
    pmsg->pcmh_value = atoi(argv[2]); /* dev_no */
    pmsg->pcmh_flags = atoi(argv[4]); /* seconds */
    cli_print(cli, "dev_no = %x seconds = 0x%x->%u", pmsg->pcmh_value,pmsg->pcmh_flags,pmsg->pcmh_flags);
    if (fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
        return (0);
    }
    free(buffer);
    return (0);

}
int
AddSwitch_ltc_set_HIFseconds_Cmds (struct cli_def *cli) {
    struct cli_command *ltc_set_hif1seconds, *Dev_No, *Dev_No_Arg;
    char buf[16], helpText[1024];
    int    dev_idx;

    /* switch  ltc_set_hif_seconds */
    ltc_set_hif1seconds = cli_register_command(cli, nkCli.nk_switch, "set_ltc_seconds_value", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tSet ltc time in seconds for host device");

    /* show  ltc_set_HIF1seconds dev_no */
    Dev_No = cli_register_command(cli, ltc_set_hif1seconds, "dev_no", NULL,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter dev_no ");

    for (dev_idx=3; dev_idx <=4; ++dev_idx) {

	snprintf(buf, sizeof(buf), "%d", dev_idx);
	snprintf(helpText, sizeof(helpText), "set dev_no %d ", dev_idx);
	/* show  ltc_set_HIFseconds dev_no [1..4] */
	Dev_No_Arg = cli_register_command(cli, Dev_No, buf , NULL,
	                      PRIVILEGE_UNPRIVILEGED, MODE_EXEC, helpText);

	/* show  ltc_set_HIFseconds dev_no [1..4] seconds */
        cli_register_command(cli, Dev_No_Arg, "seconds", Set_Ltc_HIFseconds_Callback,
                              PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter seconds");
    }
    return (0);
}
/* ---------------------- switch ltc_set_HIF1nanoseconds Command ------------------------------- */
int
Set_Ltc_HIFnanoseconds_Callback (struct cli_def *cli, char *command, char *argv[], int argc) {

    int tsize = sizeof(pcm_msg_header_t);
    unsigned char *buffer = (unsigned char *)malloc(tsize);
    int i;
    pcm_msg_header_t *pmsg;
    pmsg = (pcm_msg_header_t *)buffer;

    /* show  ltc_set_HIFnanoseconds dev_no [1..4] nanoseconds [1 to 0xFFFFFFFF] */
    if (argc < 5) {
        cli_print (cli, "Incomplete command Provide nanoseconds with in 1 to 0xFFFFFFFF value");
        return CLI_OK;
    }
    if (strcmp(argv[4], "?")==0){
        cli_print(cli, "Enter nanoseconds with in 1 to 0xFFFFFFFF value ");
        return CLI_OK;
    }
    i = atoi(argv[4]);
    if ((1 > i) ||(i > 0xFFFFFFFF)) {
        cli_print (cli, "Provide nanoseconds with in 1 to 0xFFFFFFFF value");
        return CLI_OK;
    }


    pmsg->pcmh_type = PCM_MSG_SWITCH_LTC_HIF_NANOSECONDS;
    pmsg->pcmh_value = atoi(argv[2]); /* dev_no */
    pmsg->pcmh_flags = atoi(argv[4]); /* nanoseconds */
    cli_print(cli, "dev_no = %x nanoseconds = 0x%x->%u", pmsg->pcmh_value, pmsg->pcmh_flags,pmsg->pcmh_flags);
    if (fp_ioctl_get((void *)buffer, PCM_MSG_SWITCH, tsize)){
        fprintf(stderr, "ioctl error, Unable to obtain necessary data \n");
	return (0);
    }
    free(buffer);
    return (0);

}

int
AddSwitch_ltc_set_HIFnanoseconds_Cmds (struct cli_def *cli) {
    struct cli_command *ltc_set_hif1nanoseconds, *Dev_No, *Dev_No_Arg;
    char buf[16], helpText[1024];
    int    dev_idx;

    /* switch  ltc_set_HIFnanoseconds */
    ltc_set_hif1nanoseconds = cli_register_command(cli, nkCli.nk_switch, "set_ltc_nseconds_value", NULL,
                             PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "\tSet ltc time in nano seconds for host device");

    /* show  ltc_set_HIFnanoseconds dev_no */
    Dev_No = cli_register_command(cli, ltc_set_hif1nanoseconds, "dev_no", NULL,
                             PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter dev_no ");

    for (dev_idx=3; dev_idx <=4; ++dev_idx) {

        snprintf(buf, sizeof(buf), "%d", dev_idx);
        snprintf(helpText, sizeof(helpText), "set dev_no %d ", dev_idx);
        /* show  ltc_set_HIFnanoseconds dev_no [1..4] */
        Dev_No_Arg = cli_register_command(cli, Dev_No, buf , NULL,
                             PRIVILEGE_UNPRIVILEGED, MODE_EXEC, helpText);

        /* show  ltc_set_HIFnanoseconds dev_no [1..4] seconds */
        cli_register_command(cli, Dev_No_Arg, "nanoseconds", Set_Ltc_HIFnanoseconds_Callback,
                             PRIVILEGE_UNPRIVILEGED, MODE_EXEC, "Enter seconds");
    }
    return (0);
}

int
AddSwitch_Cmds (struct cli_def *cli) {

   AddSwitch_Br_Entry_Add_Cmds(cli);
   AddSwitch_Br_Entry_Search_Cmds(cli);
   AddSwitch_Br_Entry_Add_Ports_Cmds(cli);
   AddSwitch_Br_Entry_Portlist_Get_Cmds(cli);
   AddSwitch_Br_Entry_Untaglist_Get_Cmds(cli);
   AddSwitch_Br_Entry_Port_Tag_Chg_Cmds(cli);
   AddSwitch_Br_Entry_Fwd_Action_Get_Cmds(cli);
   AddSwitch_Port_Config_Get_Cmds(cli);
   AddSwitch_Global_Br_Entry_Config_Get_Cmds(cli);
   AddSwitch_Br_Entry_Fwd_Action_Chg_Cmds(cli);
   AddSwitch_Port_Config_Cmds(cli);
   AddSwitch_Global_Br_Entry_Config_Cmds(cli);
   AddSwitch_Br_Entry_Del_Cmds(cli);
   AddSwitch_Br_Entry_Del_Ports_Cmds(cli);

   AddSwitch_Mac_Entry_Add_Cmds(cli);
   AddSwitch_Mac_Entry_Del_Cmds(cli);
   AddSwitch_Mac_Entry_Search_Cmds(cli);
   AddSwitch_Mac_Entry_Update_Cmds(cli);

   AddSwitch_ltc_get_timediff_Cmds(cli);
   AddSwitch_ltc_set_HIFseconds_Cmds(cli);
   AddSwitch_ltc_set_HIFnanoseconds_Cmds(cli);

   AddSwitch_Private_Vlan_Add_Cmds(cli);
   AddSwitch_Private_Vlan_Del_Cmds(cli);

   return (0);
}
